﻿local ARKINV_L = AceLibrary("AceLocale-2.2"):new("ARKINV")

ARKINV = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0" );
local dd = AceLibrary("Dewdrop-2.0");
local gt = AceLibrary("Gratuity-2.0");

ARKINV_G = {

	PROGRAM_NAME = "ArkInventory",
	PROGRAM_VERSION = 1.26,
	PROGRAM_BETA = nil, -- "2006-12-29-xx-xx"
	DEBUG = false,

	ME = UnitName( "player" ) .. " - " .. GetRealmName(),
	
	MODE_EDIT = false,
	MODE_BANK = false,
	MODE_COMBAT = false,

	LOCATION_BAG = 1, -- hardcoded, do not change
	LOCATION_BANK = 2, -- hardcoded, do not change
	LOCATION_KEY = 3, -- hardcoded, do not change
	LOCATION = { },
	
	WINDOW_OFFSET = 9, -- hardcoded padding size for gap inside container
	WINDOW_MIN_ROW = 1,
	WINDOW_MIN_COL = 6,
	

	FADE_ALPHA = 0.6,
	BAG_SLOT_SIZE = 20,
	
	-- slot type numbers, do not change this order, just add new ones to the end of the list
	SLOT_UNKNOWN = 0,
	SLOT_BAG = 1,
	SLOT_KEY = 3,
	SLOT_PROJECTILE = 4,
	SLOT_SOULSHARD = 5,
	SLOT_HERB = 6,
	SLOT_ENCHANTING = 7,
	SLOT_ENGINEERING = 8,
	SLOT_GEM = 9,
	SLOT_MINING = 10,
	SLOT_PROJECTILE_BULLET = 11,
	SLOT_PROJECTILE_ARROW = 12,

	GUI_NAME = "ARKINV_Ui",

	BAR_DEFAULT_COLOUR = { r = 0.0, g = 0.0, b = 0.4, a = 0.4 },
	
	SLOT_SORT_NAME = 1,
	SLOT_SORT_BAGSLOT = 2,
	
	CATEGORY = { }, -- see GenerateCategory()
	
	CATEGORY_SYSTEM = { -- do NOT change the indicies
		[0] = ARKINV_L["CATEGORY_DEFAULT"],
		[1] = ARKINV_L["CATEGORY_TRASH"],
		[11] = ARKINV_L["CATEGORY_SOULBOUND"],
		[12] = ARKINV_L["CATEGORY_CONSUMABLE"],
		[13] = ARKINV_L["CATEGORY_CONTAINER"],
		[14] = ARKINV_L["CATEGORY_KEY"],
		[15] = ARKINV_L["CATEGORY_MISCELLANEOUS"],
		[16] = ARKINV_L["CATEGORY_REAGENT"],
		[17] = ARKINV_L["CATEGORY_RECIPE"],
		[18] = ARKINV_L["CATEGORY_PROJECTILE"],
		[19] = ARKINV_L["CATEGORY_QUEST"],
		[20] = ARKINV_L["CATEGORY_TRADE_GOODS"],
		[22] = ARKINV_L["CATEGORY_SOULSHARD"],
		[23] = ARKINV_L["CATEGORY_EQUIPMENT"],
		[24] = ARKINV_L["CATEGORY_MOUNT"],
		[25] = ARKINV_L["CATEGORY_SOULBOUND_EQUIPMENT"],
		[26] = ARKINV_L["CATEGORY_FOOD"],
		[27] = ARKINV_L["CATEGORY_DRINK"],
		[28] = ARKINV_L["CATEGORY_MANAPOT"],
		[29] = ARKINV_L["CATEGORY_HEALPOT"],
		[32] = ARKINV_L["CATEGORY_PROJECTILE_BULLET"],
		[33] = ARKINV_L["CATEGORY_PROJECTILE_ARROW"],
		[34] = ARKINV_L["CATEGORY_PET_NONCOMBAT"],
		[35] = ARKINV_L["CATEGORY_CORE_MATS"],
		
	},

	CATEGORY_PROFESSION = { -- do NOT change the indicies
		[101] = ARKINV_L["CATEGORY_PROFESSION_HERBALISM"],
		[102] = ARKINV_L["CATEGORY_PROFESSION_FISHING"],
		[103] = ARKINV_L["CATEGORY_PROFESSION_MINING"],
		[104] = ARKINV_L["CATEGORY_PROFESSION_SKINNING"],
		[105] = ARKINV_L["CATEGORY_PROFESSION_ALCHEMY"],
		[106] = ARKINV_L["CATEGORY_PROFESSION_BLACKSMITHING"],
		[107] = ARKINV_L["CATEGORY_PROFESSION_COOKING"],
		[108] = ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"],
		[109] = ARKINV_L["CATEGORY_PROFESSION_LEATHERWORKING"],
		[110] = ARKINV_L["CATEGORY_PROFESSION_TAILORING"],
		[111] = ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"],
		[112] = ARKINV_L["CATEGORY_PROFESSION_FIRST_AID"],
		[113] = ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"],
	},
	
	CATEGORY_CLASS = { -- do NOT change the indicies
		[201] = ARKINV_L["CATEGORY_CLASS_DRUID"],
		[202] = ARKINV_L["CATEGORY_CLASS_HUNTER"],
		[203] = ARKINV_L["CATEGORY_CLASS_MAGE"],
		[204] = ARKINV_L["CATEGORY_CLASS_PALADIN"],
		[205] = ARKINV_L["CATEGORY_CLASS_PRIEST"],
		[206] = ARKINV_L["CATEGORY_CLASS_ROGUE"],
		[207] = ARKINV_L["CATEGORY_CLASS_SHAMAN"],
		[208] = ARKINV_L["CATEGORY_CLASS_WARLOCK"],
		[209] = ARKINV_L["CATEGORY_CLASS_WARRIOR"],
	},

	CATEGORY_EMPTY = { -- do NOT change the indicies
		[301] = ARKINV_L["CATEGORY_EMPTY"],
		[2] = ARKINV_L["CATEGORY_EMPTY_BAG"],
		[3] = ARKINV_L["CATEGORY_EMPTY_KEY"],
		[4] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE"],
		[5] = ARKINV_L["CATEGORY_EMPTY_SOULSHARD"],
		[6] = ARKINV_L["CATEGORY_EMPTY_HERB"],
		[7] = ARKINV_L["CATEGORY_EMPTY_ENCHANTING"],
		[8] = ARKINV_L["CATEGORY_EMPTY_ENGINEERING"],
		[9] = ARKINV_L["CATEGORY_EMPTY_GEM"],
		[10] = ARKINV_L["CATEGORY_EMPTY_MINING"],
		[30] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_BULLET"],
		[31] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_ARROW"],
	},
	
}

ARKINV_G.LOCATION = {

	[ARKINV_G.LOCATION_BAG] = {
		--["ORDER"] = 1,
		["NAME"] = ARKINV_L["LOCATION_BAG"],
		["TEXTURE"] = "Interface\\Icons\\INV_Misc_Bag_16",
		["IDS"] = { 0, 1, 2, 3, 4 },
		["USER"] = ARKINV_G.ME,

		["BAR_MAX"] = 0,
		["SLOT_MAX"] = 0,
		
		["OFFLINE"] = false,
		["RESCAN"] = { },

		["WINDOW"] = {
			["REBUILD"] = true,
			["REFRESH"] = true,
		},
	},

	[ARKINV_G.LOCATION_BANK] = {
		--["ORDER"] = 3,
		["NAME"] = ARKINV_L["LOCATION_BANK"],
		["TEXTURE"] = "Interface\\Icons\\INV_Box_03",
		["IDS"] = { -1, 5, 6, 7, 8, 9, 10, 11 },
		["USER"] = ARKINV_G.ME,

		["BAR_MAX"] = 0,
		["SLOT_MAX"] = 0,

		["OFFLINE"] = false,
		["RESCAN"] = { },

		["WINDOW"] = {
			["REBUILD"] = true,
			["REFRESH"] = true,
		},
	},

	[ARKINV_G.LOCATION_KEY] = {
		--["ORDER"] = 2,
		["NAME"] = ARKINV_L["LOCATION_KEY"],
		["TEXTURE"] = "Interface\\Icons\\INV_Misc_Key_04",
		["IDS"] = { -2 },
		["USER"] = ARKINV_G.ME,

		["BAR_MAX"] = 0,
		["SLOT_MAX"] = 0,

		["OFFLINE"] = false,
		["RESCAN"] = { },

		["WINDOW"] = {
			["REBUILD"] = true,
			["REFRESH"] = true,
		},
	},
}


ARKINV_SLOT_TABLE_DEFAULT_COLOUR = { r = 0.3, g = 0.3, b = 0.3 };

ARKINV_SLOT_TABLE = {
	[ARKINV_G.SLOT_UNKNOWN] = {
		["name"] = ARKINV_L["NAME_CONTAINER_UNKNOWN"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_UNKNOWN"],
		["colour"] = { r = 1.0, g = 0.0, b = 0.0 }, -- red
	},
	[ARKINV_G.SLOT_BAG] = {
		["name"] = ARKINV_L["NAME_CONTAINER_BAG"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_BAG"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
	},
	[ARKINV_G.SLOT_KEY] = {
		["name"] = ARKINV_L["NAME_CONTAINER_KEY"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_KEY"],
		["colour"] = { r = 1.0, g = 1.0, b = 0.0 }, -- yellow,
	},
	[ARKINV_G.SLOT_SOULSHARD] = {
		["name"] = ARKINV_L["NAME_CONTAINER_SOULSHARD"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_SOULSHARD"],
		["colour"] = { r = 1.0, g = 0.0, b = 1.0 }, -- magenta
	},
	[ARKINV_G.SLOT_HERB] = {
		["name"] = ARKINV_L["NAME_CONTAINER_HERB"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_HERB"],
		["colour"] = { r = 0.0, g = 1.0, b = 0.0 }, -- green
	},
	[ARKINV_G.SLOT_ENCHANTING] = {
		["name"] = ARKINV_L["NAME_CONTAINER_ENCHANTING"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_ENCHANTING"],
		["colour"] = { r = 0.0, g = 0.0, b = 1.0 }, -- blue
	},
	[ARKINV_G.SLOT_ENGINEERING] = {
		["name"] = ARKINV_L["NAME_CONTAINER_ENGINEERING"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_ENGINEERING"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
	},
	[ARKINV_G.SLOT_GEM] = {
		["name"] = ARKINV_L["NAME_CONTAINER_GEM"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_GEM"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
	},
	[ARKINV_G.SLOT_MINING] = {
		["name"] = ARKINV_L["NAME_CONTAINER_MINING"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_MINING"],
		["colour"] = ARKINV_SLOT_TABLE_DEFAULT_COLOUR,
	},
	[ARKINV_G.SLOT_PROJECTILE] = {
		["name"] = ARKINV_L["NAME_CONTAINER_PROJECTILE"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
	},
	[ARKINV_G.SLOT_PROJECTILE_BULLET] = {
		["name"] = ARKINV_L["NAME_CONTAINER_PROJECTILE_BULLET"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_BULLET"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
	},
	[ARKINV_G.SLOT_PROJECTILE_ARROW] = {
		["name"] = ARKINV_L["NAME_CONTAINER_PROJECTILE_ARROW"],
		["long"] = ARKINV_L["CATEGORY_EMPTY_PROJECTILE_ARROW"],
		["colour"] = { r = 1.0, g = 0.5, b = 0.15 }, -- orange
	}
}


-- Binding Variables
BINDING_HEADER_ARKINV = ARKINV_G.PROGRAM_NAME;
BINDING_NAME_ARKINV_TOGGLE_BAG = ARKINV_L["BINDING_TOGGLE_BAG"];
BINDING_NAME_ARKINV_TOGGLE_KEY = ARKINV_L["BINDING_TOGGLE_KEY"];
BINDING_NAME_ARKINV_TOGGLE_BANK = ARKINV_L["BINDING_TOGGLE_BANK"];
BINDING_NAME_ARKINV_TOGGLE_EDIT = ARKINV_L["BINDING_TOGGLE_EDIT"];


ARKINV:RegisterDB( "ARKINVDB" );

ARKINV:RegisterDefaults( "profile", {
	["option"] = {
		["window"] = {
			["scale"] = 1,
			["col"] = 12,
			["colour"] = {
				["background"] = {
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
					["a"] = 0.75,
				},
			},
			["ignorehidden"] = false,
			["auto"] = {
				["open"] = {
					["bank"] = true,
					["mail"] = true,
					["trade"] = true,
					["merchant"] = true,
					["auction"] = true,
				},
				["close"] = {
					["bank"] = true,
					["mail"] = true,
					["trade"] = true,
					["merchant"] = true,
					["auction"] = true,
					["combat"] = true,
				},
			},
		},
		["bar"] = {
			["per"] = 3,
			["pad"] = 0,
			["border"] = false,
			["colour"] = {
				["background"] = ARKINV_G.BAR_DEFAULT_COLOUR,
				["border"] = ARKINV_G.BAR_DEFAULT_COLOUR,
			},
		},
		["slot"] = {
			["empty"] = {
				["alpha"] = 0.1,
				["icon"] = true,
				["clump"] = false,
			},
			["data"] = ARKINV_SLOT_TABLE,
			["pad"] = 2,
			["border"] = true,
			["fade"] = true,
		},
		["sort"] = {
			["type"] = ARKINV_G.SLOT_SORT_BAGSLOT,
			["quality"] = false,
		},
		["category"] = {
			["location"] = { -- [category id] = bar number
				[0] = 1,
			},
			["custom"] = {
--[[
				[-1] = "1",
				[-2] = "2",
				[-3] = "3",
				[-4] = "4",
				[-5] = "5",
				[-6] = "6",
				[-7] = "7",
				[-8] = "8",
				[-9] = "9",
]]--
			},
			["next"] = -10,  -- id for next custom category
			["item"] = {  -- item id = category
				["0.0.0"] = 0,
			},
		},
		["offline"] = {
			["bank"] = true,
			["alt"] = true,
		},
	},

} );

ARKINV:RegisterDefaults( "account", {
	["cache"] = {
		["who"] = {
			["*"] = {
				["loc"] = {
					["*"] = {
						["bag"] = { },
						["bar"] = { },
						["container"] = { },

						["slot_count"] = 0,
						["bar_count"] = 0,
					},
				},
			},
		},
	},
	
} );


		

local ARKINV_SlashCommandOptions = {
	type = "group",
	args = {

		gui = {
			type = "group",
			name = "gui",
			desc = "gui options",
			args = {
				reset = {
					type = "execute",
					name = "reset",
					desc = "centers the user interface on the screen",
					func = function()
						for loc_id in pairs( ARKINV_G.LOCATION ) do
							getglobal( ARKINV_G.GUI_NAME .. loc_id ):SetPoint( "TOPLEFT", UiParent, "CENTER" )
						end
					end
				},
			},
		},
		
		db = {
			type = "group",
			name = "db",
			desc = "db options",
			args = {
				reset = {
					type = "group",
					name = "reset",
					desc = "resets all user options back to the defaults",
					args = {
						confirm = {
							type = "execute",
							name = "confirm",
							desc = "confirms the database reset",
							func = function() ARKINV:ReloadDatabase() end
						},
					},
				},
			},
		},
		
		cache = {
			type = "group",
			name = "cache",
			desc = "cache options",
			args = {
				erase = {
					type = "group",
					name = "erase",
					desc = "erases all cached data",
					args = {
						confirm = {
							type = "execute",
							name = "confirm",
							desc = "confirms the cache erase",
							func = function() ARKINV:ReloadCache() end
						},
					},
				},
			},
		},

	},
}

ARKINV:RegisterChatCommand( { "/arkinv", "/ai" }, ARKINV_SlashCommandOptions )


function ARKINV:DefaultOptionBar()

	self.db.profile.option["bar"] = { }
	
end


function ARKINV:DefaultOptionSlot()

	self.db.profile.option["slot"] = { }

end


function ARKINV:ReloadDatabase()

	self:ResetDB( "profile" );
	self:Print( "Database has been reset." );
	self:Print( "All user options are back at factory defaults." )
	
	self:GenerateCategory();
	self:BagScanAll();
	self:UiClose();

end


function ARKINV:ReloadCache()

	self:ResetDB( "account" );
	self:Print( "All cached data has been erased." )
	
	self:GenerateCategory();
	self:UiClose();
	self:BagScanRequiredAll();
	

end










function ARKINV:Debug( msg )
	if ARKINV_G.DEBUG then
		if ( DEFAULT_CHAT_FRAME ) then
			ARKINV:Print( msg )
		end
	end
end

function ARKINV:tableSum( tbl, fcn ) --fcn(v)
	local r = 0
	for k, v in pairs( tbl ) do
		r = r + ( fcn( v ) or 0 )
	end
	return r
end

function ARKINV:tableMax( tbl, fcn )
	local r = nil
	for k, v in pairs( tbl ) do
		if not r then
			r = ( fcn( v ) or 0 )
		else
			if ( fcn( v ) or 0 ) > r then
				r = ( fcn( v ) or 0 )
			end
		end
	end
	return r
end

function ARKINV:tableElements( tbl )
	local r = 0
	for _, _ in pairs( tbl ) do
		r = r + 1;
	end
	return r
end




function ARKINV:spairs( tbl, comparator )

	local sortedKeys = {};
	for k, v in pairs( tbl ) do
		tinsert( sortedKeys, k )
	end;
	sort( sortedKeys, comparator );
	local i = 0;
	local function _f( _s, _v )
		i = i + 1;
		local k = sortedKeys[i];
		if ( k ) then
			return k, tbl[k];
		end
	end
	return _f, nil, nil;
end







function ARKINV:OnInitialize()
	-- Called when the addon is loaded

	self:RemoveOldOptions();

end


function ARKINV:OnEnable()
	-- Called when the addon is enabled


	self:GenerateCategory();

	self:RegisterBucketEvent( "BAG_UPDATE", 0.5 );
	self:RegisterEvent( "ITEM_LOCK_CHANGED" );
	
	self:RegisterEvent( "BAG_UPDATE_COOLDOWN" );
	
	
	
	self:RegisterEvent( "PLAYERBANKSLOTS_CHANGED" ); -- one of the slots in bag -1 (main bank) have changed

	--self:RegisterEvent( "UPDATE_INVENTORY_ALERTS" );
	--self:RegisterEvent( "UNIT_INVENTORY_CHANGED" );
	
	
	
	
	self:RegisterEvent( "PLAYER_REGEN_DISABLED" ); -- player about to enter combat
	self:RegisterEvent( "PLAYER_REGEN_ENABLED" ); -- player left combat

	self:RegisterEvent( "BANKFRAME_OPENED" );
	self:RegisterEvent( "BANKFRAME_CLOSED" );
	
	self:RegisterEvent( "MAIL_SHOW" );
	self:RegisterEvent( "MAIL_CLOSED" );

	self:RegisterEvent( "TRADE_SHOW" );
	self:RegisterEvent( "TRADE_CLOSED" );

	self:RegisterEvent( "AUCTION_HOUSE_SHOW" );
	self:RegisterEvent( "AUCTION_HOUSE_CLOSED" );

	self:RegisterEvent( "MERCHANT_SHOW" );
	self:RegisterEvent( "MERCHANT_CLOSED" );
	
	
	
	self:RegisterEvent( "PLAYER_LOGIN" ); --Triggered immediately before PLAYER_ENTERING_WORLD on login and UI Reload, but NOT when entering/leaving instances.
	self:RegisterEvent( "PLAYER_LOGOUT" ); --Sent when the player logs out or the UI is reloaded, after PLAYER_LEAVING_WORLD, but before variables are saved.
	--self:RegisterEvent( "PLAYER_QUIT" );
	

	-- tag all bags as needed to be scanned
	self:BagScanRequiredAll();
	
	self:Print( "v" .. ARKINV_G.PROGRAM_VERSION .. " Enabled.  Type /ARKINV or /AI for help." )
	
end


function ARKINV:OnDisable()
	-- Called when the addon is disabled

	--self:UnhookAll();
	
	self:UiClose();
	
	self:Debug( "Disabled" );
	
end


function ARKINV:BAG_UPDATE( arg1_bucket )

	for bagnum in pairs( arg1_bucket ) do

		self:Debug( RED_FONT_COLOR_CODE .. "BAG_UPDATE( " .. bagnum .. " )" );
		-- a bag just had it's contents changed, usually triggers in pairs

--[[
	if arg1 ~= 0 then
		-- normal bag, scan it
		self:BagScan( arg1 );
		self:GenerateContainerActual( self:BagLocation( arg1 ) );
	elseif ARKINV_G.MODE_BANK then
		-- at the bank, scan all bags on any bag change because it's the only way to capture all updates properly
		self:BagScanAll();
		self:GenerateContainerAll();
	elseif not ARKINV_G.MODE_COMBAT then
		-- bag 0 changed and we're not in combat, scan all bags because it's the only way to capture all updates properly
		-- in combat bag 0 updates are generated by inventory items, like a weapon with posion applied, every use triggers a bag 0 update
		self:BagScanAll();
		self:GenerateContainerAll();
	else
		self:Debug( date() .. " ignored, in combat" );
	end
]]--


		if ARKINV_G.MODE_BANK then
			-- at the bank, scan everything - stupid corner cases require this
			self:BagScanRequiredAll();
		else
			self:BagScanRequired( { bagnum } );
		end
	
    end


	self:GenerateContainerAll();
	
end

function ARKINV:BAG_UPDATE_COOLDOWN( arg1 )
	
	-- no cooldown data is saved so a scan is not required, just draw the window
	
	if not arg1 then

		self:Debug( RED_FONT_COLOR_CODE .. "BAG_UPDATE_COOLDOWN( nil )" );
		
		if not ARKINV_G.MODE_COMBAT then
			self:GenerateContainerAll();
		end
		
	else

		self:Debug( RED_FONT_COLOR_CODE .. "BAG_UPDATE_COOLDOWN( " .. arg1 .. " )" );
		
		if not ARKINV_G.MODE_COMBAT then
			self:GenerateContainer( self:BagLocation( arg1 ) );
		end
		
	end
	
end

function ARKINV:ITEM_LOCK_CHANGED()
	-- no lock data is saved so a scan is not required, just draw the window

	self:Debug( RED_FONT_COLOR_CODE .. "ITEM_LOCK_CHANGED()" );
	
		if not ARKINV_G.MODE_COMBAT then
			self:GenerateContainerAll();
		end
	
end

function ARKINV:UPDATE_INVENTORY_ALERTS()

	self:Debug( RED_FONT_COLOR_CODE .. "UPDATE_INVENTORY_ALERTS()" );

end

function ARKINV:UNIT_INVENTORY_CHANGED( arg1 )

	self:Debug( RED_FONT_COLOR_CODE .. "UNIT_INVENTORY_CHANGED( " .. arg1 .. " )" );

end





function ARKINV:PLAYER_REGEN_DISABLED()
	-- entered combat
	
	self:Debug( RED_FONT_COLOR_CODE .. "PLAYER_REGEN_DISABLED()" );
	
	ARKINV_G.MODE_COMBAT = true;
	
	if self.db.profile.option.window.auto.close.combat then
		self:UiClose();
	end
	
end

function ARKINV:PLAYER_REGEN_ENABLED()
	-- left combat
	
	self:Debug( RED_FONT_COLOR_CODE .. "PLAYER_REGEN_ENABLED()" );
	
	ARKINV_G.MODE_COMBAT = false;
	self:GenerateContainerAll();
	
end

function ARKINV:BANKFRAME_OPENED()

	self:Debug( RED_FONT_COLOR_CODE .. "BANKFRAME_OPENED()" );
	
	ARKINV_G.MODE_BANK = true;
	
	self:BagScanRequiredAll();
		
	if self.db.profile.option.window.auto.open.bank then
		self:UiOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
		self:UiOpen( ARKINV_G.LOCATION_BANK, ARKINV_G.ME );
	else
		-- regenerate the view in case they were looking at the bank "offline", make it "online"
		self:UiOpen( ARKINV_G.LOCATION_BANK, ARKINV_G.ME );
	end

	self:GenerateContainerRefresh( ARKINV_G.LOCATION_BANK );
	
end

function ARKINV:BANKFRAME_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "BANKFRAME_CLOSED()" );
	
	ARKINV_G.MODE_BANK = false;

	if self.db.profile.option.window.auto.close.bank then
		self:UiClose( ARKINV_G.LOCATION_BANK );
	end

	self:GenerateContainerRefresh( ARKINV_G.LOCATION_BANK );
	
end

function ARKINV:PLAYERBANKSLOTS_CHANGED()
	self:Debug( RED_FONT_COLOR_CODE .. "PLAYERBANKSLOTS_CHANGED" );
	self:BagScanAll();
	self:GenerateContainerAll();
end


function ARKINV:MAIL_SHOW()

	self:Debug( RED_FONT_COLOR_CODE .. "MAIL_SHOW" );

	if self.db.profile.option.window.auto.open.mail then
		self:UiOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
	end

end

function ARKINV:MAIL_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "MAIL_CLOSED" );
	
	if self.db.profile.option.window.auto.close.mail then
		self:UiClose( ARKINV_G.LOCATION_BAG );
	end

end

function ARKINV:TRADE_SHOW()

	self:Debug( RED_FONT_COLOR_CODE .. "TRADE_SHOW" );
	
	if self.db.profile.option.window.auto.open.trade then
		self:UiOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
	end

end

function ARKINV:TRADE_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "TRADE_CLOSED" );
	
	if self.db.profile.option.window.auto.close.trade then
		self:UiClose( ARKINV_G.LOCATION_BAG );
	end

end

function ARKINV:AUCTION_HOUSE_SHOW()

	self:Debug( RED_FONT_COLOR_CODE .. "AUCTION_HOUSE_SHOW" );
	
	if self.db.profile.option.window.auto.open.auction then
		self:UiOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
	end

end

function ARKINV:AUCTION_HOUSE_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "AUCTION_HOUSE_CLOSED" );
	
	if self.db.profile.option.window.auto.close.auction then
		self:UiClose();
	end

end

function ARKINV:MERCHANT_SHOW()

	self:Debug( RED_FONT_COLOR_CODE .. "MERCHANT_SHOW" );
	
	if self.db.profile.option.window.auto.open.merchant then
		self:UiOpen( ARKINV_G.LOCATION_BAG, ARKINV_G.ME );
	end

end

function ARKINV:MERCHANT_CLOSED()

	self:Debug( RED_FONT_COLOR_CODE .. "MERCHANT_CLOSED" );
	
	if self.db.profile.option.window.auto.close.merchant then
		self:UiClose();
	end

end


function ARKINV:PLAYER_LOGIN()

	self:Debug( RED_FONT_COLOR_CODE .. "PLAYER_LOGIN" );

	self:CacheCleanup();

end

function ARKINV:PLAYER_LOGOUT()

	self:Debug( RED_FONT_COLOR_CODE .. "PLAYER_LOGOUT" );

	self:BagScanRequiredAll();
	self:BagScanAll();

	self:CacheCleanup();

end

function ARKINV:PLAYER_QUIT()

	self:Debug( RED_FONT_COLOR_CODE .. "PLAYER_LOGOUT" );

	self:CacheCleanup();

end






function ARKINV:UiOpen( loc_id, user )

	if user then
		ARKINV_G.LOCATION[loc_id].USER = user
	end

	getglobal( ARKINV_G.GUI_NAME .. loc_id ):Show();
	self:GenerateContainerActual( loc_id )
	
end

function ARKINV:UiClose( w )

	for loc_id in pairs( ARKINV_G.LOCATION ) do
		if not w or w == loc_id then
			getglobal( ARKINV_G.GUI_NAME .. loc_id ):Hide();
		end
	end
	
	-- if the current window is in edit mode then disable edit mode and taint window when it's closed so it's rebuilt when next opened
	
	if ARKINV_G.MODE_EDIT then
		ARKINV_G.MODE_EDIT = false;
		self:GenerateContainerRebuildAll();
	end
	
end

function ARKINV:UiToggle( loc_id )
	if getglobal( ARKINV_G.GUI_NAME .. loc_id ):IsVisible() then
		self:UiClose( loc_id )
	else
		self:UiOpen( loc_id )
	end
end


function ARKINV:BagScanAll()

	self:Debug( date() .. " BagScanAll() start" );

	for loc_id in pairs( ARKINV_G.LOCATION ) do
		for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
			self:BagScan( bagnum );
		end
	end
	
	self:Debug( date() .. " BagScanAll() end" );
	
end


function ARKINV:BagScan( bagnum )

	if not ( bagnum ) then
		return
	end

	self:Debug( date() .. " BagScan( " .. bagnum .. " ) start" )

	local loc_id = self:BagLocation( bagnum );
	if not loc_id then
		return
	end

	
	-- check rescan tag
	if not ARKINV_G.LOCATION[loc_id].RESCAN[bagnum] then
		self:Debug( date() .. " aborted scan of bag " .. bagnum .. ", no recorded change" )
		return
	end

	if loc_id == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE_BANK == false then
		self:Debug( date() .. " aborted scan of bag " .. bagnum .. ", not at bank" )
		return
	end


	local tainted = false;
	
	local bag = { }
	bag["count"] = GetContainerNumSlots( bagnum );
	bag["empty"] = 0;
	bag["type"] = self:BagType( bagnum );
	bag["slot"] = { };
	
	local ob, oi, i, item_id, item_suffix, item_enchant, item_soulbound

	--self:Debug( "bag " .. bagnum .. " has " .. bag.count .. " slots" )
	
	for slotnum = 1, bag.count do
	
		i = { }
		
		i["h"] = GetContainerItemLink( bagnum, slotnum );
		

		if i.h then
			i["texture"], i["count"] = GetContainerItemInfo( bagnum, slotnum );
			i["name"], _, i["q"] = GetItemInfo( i.h );
			item_id, item_enchant, item_suffix = strmatch( i.h, "|Hitem:(%d+):(%d+):(%d+):" );

			-- check for soulbound
			if bagnum == -1 then
				-- bank slot
				--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " bank tooltip" )
				gt:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) );
			elseif bagnum == -2 then
				-- keyring slot
				--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " keyring tooltip" )
				gt:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) );
			else
				--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " standard tooltip" )
				gt:SetBagItem( bagnum, slotnum );
			end

			if gt:Find( ARKINV_L["TOOLTIP_SOULBOUND"] ) then
				--self:Debug( "bag=" .. bagnum .. ", slot=" .. slotnum .. " found soulbound in tooltip" )
				i["sb"] = true;
				item_soulbound = "1";
			else
				item_soulbound = nil;
			end

		else
			-- empty slot

			bag.empty = bag.empty + 1;
			
			item_id = nil;
			item_enchant = nil;
			item_suffix = nil;
			item_soulbound = nil;

		end

		if not i.name then i.name = ""; end
		if not i.count then i.count = 0; end
		if not i.q then i.q = 0; end
		if not item_id then item_id = "0" end
		if not item_suffix then item_suffix = "0" end
		if not item_enchant then item_enchant = "0" end
		if not item_soulbound then item_soulbound = "0" end
		

		i["id"] = item_id .. "." .. item_soulbound .. "." .. item_suffix .. "." .. item_enchant;
		
		i["cat"], i["catdef"] = self:ItemCategoryGet( i, bag.type, bagnum, slotnum )
		
		-- save the data
		bag.slot[slotnum] = i;

		

		if not tainted then

			ob = self.db.account.cache.who[ARKINV_G.ME].loc[loc_id].bag[bagnum];

			if not ob then
			
				--  bag added
				self:Debug( date() .. " tainted, bag=" .. bagnum .. ", new bag" );
				tainted = true;
				
			else
			
				oi = ob.slot[slotnum];
				
				if not oi then
					--  the old slot doesnt exist - bag increased in size?
					self:Debug( date() .. " tainted, bag=" .. bagnum .. ", slot=" .. slotnum .. ", new slot " );
					tainted = true;
				elseif ( i.h and not oi.h ) then
					-- the name changed
					self:Debug( date() .. " tainted, bag=" .. bagnum .. ", slot=" .. slotnum .. ", item added " );
					tainted = true;
				elseif ( not i.h and oi.h ) then
					-- the name changed
					self:Debug( date() .. " tainted, bag=" .. bagnum .. ", slot=" .. slotnum .. ", item removed " );
					tainted = true;
				elseif ( i.h and oi.h and i.h ~= oi.h ) then
					-- the name changed
					self:Debug( date() .. " tainted, bag=" .. bagnum .. ", slot=" .. slotnum .. ", item changed " );
					tainted = true;
				elseif ( i.sb and not oi.sb ) or ( not i.sb and oi.sb ) then
					-- soubound changed
					self:Debug( date() .. " tainted, bag=" .. bagnum .. ", slot=" .. slotnum .. ", soulbound changed " );
					tainted = true;
				elseif ( i.cat and not oi.cat ) or ( not i.cat and oi.cat ) or ( i.cat and oi.cat and i.cat ~= oi.cat ) then
					-- category changed
					self:Debug( date() .. " tainted, bag=" .. bagnum .. ", slot=" .. slotnum .. ", category changed " );
					tainted = true;
				elseif i.count ~= oi.count then
					-- item count changed, not tainted but needs refresh
					ARKINV_G.LOCATION[loc_id].WINDOW.REFRESH = true;
				end
			
			end
			
		end
		
	end

	
	if tainted then
		self:Debug( "tainted, force rebuild" )
		ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD = true;
	end

	self.db.account.cache.who[ARKINV_G.ME].loc[loc_id].bag[bagnum] = bag

	-- reset rescan tag
	ARKINV_G.LOCATION[loc_id].RESCAN[bagnum] = nil;
	
	self:Debug( date() .. " BagScan( " .. bagnum .. " ) end" );
	
end


function ARKINV:CategoryLocationSet( category_id, barnum )
	if category_id ~= 0 or barnum then
		self.db.profile.option.category.location[category_id] = barnum
	end
end


function ARKINV:CategoryLocationGet( category_id )
	-- maps category id's to the bars they are assigned to
	if not self.db.profile.option.category.location[category_id] then
		-- if this category hasn't been assigned to a bar then return the bar that DEFAULT is using
		return self.db.profile.option.category.location[0];
	else
		return self.db.profile.option.category.location[category_id];
	end
end

function ARKINV:CategoryHiddenCheck( category_id )

	if self.db.profile.option.category.location[category_id] and self.db.profile.option.category.location[category_id] < 0 then
		return true;
	else
		return false;
	end

end

function ARKINV:CategoryHiddenToggle( category_id )
	if category_id ~= 0 then
		self.db.profile.option.category.location[category_id] = ( 0 - self:CategoryLocationGet( category_id ) );
	end
end




function ARKINV:CalculateBars( loc_id )

	self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " CalculateBars( " .. loc_id .. " ) start " )

	local mem = gcinfo();
	
	if not ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD then
		self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " CalculateBars( " .. loc_id .. " ) aborted, not needed " )
	end
	
	
	local current_user = ARKINV_G.LOCATION[loc_id].USER
	
	self.db.account.cache.who[current_user].loc[loc_id].bar = { }
	self.db.account.cache.who[current_user].loc[loc_id].bar_count = 15;
	
	local barnum;

	-- load the inventory into their respective bars
	for bagnum, bag in pairs( self.db.account.cache.who[current_user].loc[loc_id].bag ) do
	
		for slotnum, slot in pairs( bag.slot ) do
		
			barnum = self:CategoryLocationGet( slot.cat )
	
			if barnum > 0 or self.db.profile.option.window.ignorehidden then  -- hidden categories reside on negative bar numbers so they don't get displayed
	
				barnum = abs( barnum );
	
				-- create the bar
				if not self.db.account.cache.who[current_user].loc[loc_id].bar[barnum] then
					self.db.account.cache.who[current_user].loc[loc_id].bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 0, ["width"] = 0, ["height"] = 0, ["frame"] = 0, ["ghost"] = false };
				end
		
				-- add the item to the bar
				tinsert( self.db.account.cache.who[current_user].loc[loc_id].bar[barnum].item, { ["bag"] = bagnum, ["slot"] = slotnum } )
			
				-- increment the bars item count
				self.db.account.cache.who[current_user].loc[loc_id].bar[barnum].count = self.db.account.cache.who[current_user].loc[loc_id].bar[barnum].count + 1
			
				-- keep track of the last bar used
				if barnum > self.db.account.cache.who[current_user].loc[loc_id].bar_count then
					self.db.account.cache.who[current_user].loc[loc_id].bar_count = barnum
				end

				--self:Debug( "bag[" .. bagnum .. "], slot[" .. slotnum .. "], cat[" .. slot.cat .. "], bar[" .. barnum .. "], id=[" .. vb[barnum].id .. "]" )
				
			end
			
		end
		
	end

	-- round up to a full number of bars per row
	self.db.account.cache.who[current_user].loc[loc_id].bar_count = ceil( self.db.account.cache.who[current_user].loc[loc_id].bar_count / self.db.profile.option.bar.per ) * self.db.profile.option.bar.per
	
	-- update the maximum number of bar frames used so far
	if self.db.account.cache.who[current_user].loc[loc_id].bar_count > ARKINV_G.LOCATION[loc_id].BAR_MAX then
		ARKINV_G.LOCATION[loc_id].BAR_MAX = self.db.account.cache.who[current_user].loc[loc_id].bar_count
	end
	
	-- if we're in edit mode then create 1 slot bars for any empty ones
	if ARKINV_G.MODE_EDIT then
		self:Debug( "edit mode - adding ghost bars" );
		for barnum = 1, self.db.account.cache.who[current_user].loc[loc_id].bar_count do
			if not self.db.account.cache.who[current_user].loc[loc_id].bar[barnum] then
				self.db.account.cache.who[current_user].loc[loc_id].bar[barnum] = { ["id"] = barnum, ["item"] = { }, ["count"] = 1, ["width"] = 0, ["height"] = 0, ["frame"] = 0, ["ghost"] = true };
			end
		end
	end
	
	mem = gcinfo() - mem;
	
	self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " CalculateBars( " .. loc_id .. " ) end - " .. mem )
	
end



function ARKINV:CalculateContainer( loc_id )

	self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " CalculateContainer( " .. loc_id .. " ) start " )

	local mem = gcinfo();

	if not ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD then
		self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " CalculateContainer( " .. loc_id .. " ) aborted, not needed " )
	end


	local current_user = ARKINV_G.LOCATION[loc_id].USER;

	self.db.account.cache.who[current_user].loc[loc_id].container = { ["row"] = { } }
	
	local bpr = self.db.profile.option.bar.per
	local rownum = 0
	local bf = 1 -- bar frame, allocated to each bar as it's calculated (uses less frames this way)
	
	self:Debug( "container has " .. self.db.account.cache.who[current_user].loc[loc_id].bar_count .. " bars" )
	self:Debug( "container set for " .. bpr .. " bars per row" )
	
	for j = 1, self.db.account.cache.who[current_user].loc[loc_id].bar_count, bpr do
		
		local bc = 0  -- number of bars in this row
		local vr = { }  -- virtual row - holds a list of bars for this row

		for b = 1, bpr do
			if self.db.account.cache.who[current_user].loc[loc_id].bar[j+b-1] then
				if self.db.account.cache.who[current_user].loc[loc_id].bar[j+b-1].count > 0 then
					-- self:Debug( "assignment: bar=" .. j+b-1 .. ", frame=" .. bf )
					self.db.account.cache.who[current_user].loc[loc_id].bar[j+b-1]["frame"] = bf
					bf = bf + 1
					bc = bc + 1
					tinsert( vr, self.db.account.cache.who[current_user].loc[loc_id].bar[j+b-1] )
				else
					-- self:Debug( "bar " .. j+b-1 .. " has no items" )
				end
			else
				-- self:Debug( "bar " .. j+b-1 .. " does not exist" )
			end
		end
		
		-- self:Debug( "row " .. rownum .. " allocated " .. bc .. " bars" )
		
		if bc > 0 then
		
			rownum = rownum + 1
			if not self.db.account.cache.who[current_user].loc[loc_id].container.row[rownum] then
				self.db.account.cache.who[current_user].loc[loc_id].container.row[rownum] = { }
			end
			
			self.db.account.cache.who[current_user].loc[loc_id].container.row[rownum].bar = vr

		end

	end

	
	-- fit the bars into the row

	local rmw = self.db.profile.option.window.col  -- row max width
	local rcw = 0 -- row current width
	local rch = 1 -- row current height
	local rmh = 0 -- row max height
		
	for rownum, row in ipairs( self.db.account.cache.who[current_user].loc[loc_id].container.row ) do
			
		for bagnum, bar in ipairs( row.bar ) do

			-- self:Debug( "row=" .. rownum .. ", bag=" .. bagnum )
			
			bar.width = floor( bar.count / rmw )
			if bar.width < 1 then
				bar.width = 1
			end
			
			bar.height = ceil( bar.count / bar.width )
				
			if bar.height > rmh then
				rmh = bar.height
			end
				
		end
			
		if rmh > 1 then

			repeat
			
				rcw = 0
				rmh = 0
				rmb = 0
				
				-- find bar with highest height
				for barnum, bar in ipairs( row.bar ) do
					if bar.height > rmh then
						rmh = bar.height
						rmb = barnum
					end
				end

				-- increase that bars width by one
				row.bar[rmb].width = row.bar[rmb].width + 1
				
				-- and recalcualte it's new height
				row.bar[rmb].height = ceil( row.bar[rmb].count / row.bar[rmb].width )
				
				-- and see if that all fits
				rcw = self:tableSum( row.bar, function( a ) return a.width; end );
				
				rmh = self:tableMax( row.bar, function( a ) return a.height; end );
					
				-- exit if the width fits or the max height is 1
			until rcw >= rmw or rmh == 1
			
		end
			
		--self:Debug( "maximum height for row " .. rownum .. " was " .. rmh )
		for _, bar in pairs( row.bar ) do
			-- set height of all bars in the row to the maximum height used (looks better)
			bar.height = rmh
			
			-- reset item count to zero for ghost bars
			if bar.ghost then
				bar.count = 0
			end
		end
		
	end
	

	mem = gcinfo() - mem;
	
	self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " CalculateContainer( " .. loc_id .. " ) end - " .. mem )

end


function ARKINV:FrameUpdate( loc_id )

	local p = ARKINV_G.GUI_NAME .. loc_id;
	
	local current_user = ARKINV_G.LOCATION[loc_id].USER;
	
	-- set dragable frame width
	getglobal( p ):SetWidth( self.db.account.cache.who[current_user].loc[loc_id].container.width );

	local sf = getglobal( p .. "Status" )
	
	-- adjust gold frame
	local mf = getglobal( p .. "MoneyFrame" )
	mf:SetPoint( "RIGHT", sf:GetName(), "RIGHT" )

	
	-- update the empty slot count
	local empty = { }
	local st = getglobal( p .. "StatusText" )
	for k, bag in pairs( self.db.account.cache.who[current_user].loc[loc_id].bag ) do
		if not empty[bag.type] then
			empty[bag.type] = { ["count"] = 0, ["empty"] = 0, ["type"]=bag.type }
		end
		empty[bag.type].count = empty[bag.type].count + bag.count
		empty[bag.type].empty = empty[bag.type].empty + bag.empty
	end

	local name = sf:GetName() .. "Text"
	local obj = getglobal( name )
	if not obj then
		obj = sf:CreateFontString( name, "ARTWORK", "GameFontNormal" );
		obj:SetPoint( "LEFT", sf, "LEFT", ARKINV_G.WINDOW_OFFSET, 0 );
		obj:SetTextColor( 1, 1, 1, 1 );
	end
	
	local ee = self:tableSum( empty, function( a ) return a.empty; end );
	local ts = self.db.account.cache.who[current_user].loc[loc_id].slot_count;
	
	local y = "";
	if ee == 0 then
		y = RED_FONT_COLOR_CODE .. ARKINV_L["STATUS_FULL"];
	else
		y = y .. ee .. "/" .. ts;
	end

	if ts == 0 then
		y = RED_FONT_COLOR_CODE .. ARKINV_L["STATUS_NO_DATA"];
	end

	
	if ts ~= 0 and self:tableElements( empty ) > 1 then
		local z = 0
		local x
		y = y .. "  -  "
		for t, e in self:spairs( empty, function(a,b) return empty[a].type < empty[b].type end ) do
			z = z + 1
			--x = e.empty .. "/" .. e.count .. " " .. self:BagTypeText( t )
			x = e.empty .. " " .. self.db.profile.option.slot.data[t].name
			if e.empty == 0 then
				x = RED_FONT_COLOR_CODE .. x .. FONT_COLOR_CODE_CLOSE
			end
			
			if z == 1 then
				y = y .. x
			else
				y = y .. ", " .. x
			end
			
		end
	end
	obj:SetText( y )
	
end


function ARKINV:GenerateCategory()

	categories = {
		[ARKINV_L["CATEGORY_SYSTEM"]] = ARKINV_G.CATEGORY_SYSTEM,
		[ARKINV_L["CATEGORY_PROFESSION"]] = ARKINV_G.CATEGORY_PROFESSION,
		[ARKINV_L["CATEGORY_CLASS"]] = ARKINV_G.CATEGORY_CLASS,
		[ARKINV_L["CATEGORY_EMPTY"]] = ARKINV_G.CATEGORY_EMPTY,
		[ARKINV_L["CATEGORY_CUSTOM"]] = self.db.profile.option.category.custom,
	}
	
	local n
	
	ARKINV_G.CATEGORY = { }

	for t, category in pairs( categories ) do
		for id, name in pairs( category ) do
	
			n = name
			if t == ARKINV_L["CATEGORY_CUSTOM"] then
				n = ARKINV_L["CATEGORY_CUSTOM"] .. ": " .. n;
			end

			tinsert( ARKINV_G.CATEGORY, { ["id"]=id, ["name"]=n, ["type"]="CATEGORY_" .. t } )
			
		end
	end

end

function ARKINV:GetCategoryName( category_id )

	for _, v in pairs( ARKINV_G.CATEGORY ) do
		if category_id == v.id then
			return v.name
		end
	end

	return ( "UNKNOWN CATEGORY: " .. category_id )
	
end


function ARKINV:CategoryCustomAdd( name )
	self.db.profile.option.category.custom[self.db.profile.option.category.next] = strtrim( name );
	self.db.profile.option.category.next = self.db.profile.option.category.next - 1;
	self:Print( "Added custom category: " .. name );
	self:GenerateCategory();
end

function ARKINV:CategoryCustomRename( id, name )
	self:Debug( "renaming category " .. id .. " to [" .. name .. "]" )
	self.db.profile.option.category.custom[id] = strtrim( name );
	self:GenerateCategory();
end

function ARKINV:CategoryCustomDelete( id, confirm )
	if confirm == "confirm" then
		self:Print( "Delete custom category successful: " .. self.db.profile.option.category.custom[id] .. " has been deleted" );
		self.db.profile.option.category.custom[id] = nil;
		self:GenerateCategory();
		dd:Close();
	else
		self:Print( "Delete custom category failed, confirmation not valid" );
	end
end


function ARKINV:GenerateItems( bar, bar_frame, button_offset )

	--self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " GenerateItems( " ..bar_frame:GetName() .. " ) start " )

	local mem = gcinfo();
	
	if bar.count == 0 or bar.ghost then
		return
	end
	
	local parent = bar_frame:GetParent():GetName()
	
	local loc_id = self:UiLocationID( bar_frame:GetName() );

	local current_user = ARKINV_G.LOCATION[loc_id].USER;

	local i, t


	if ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD then	
	
		local bagnum, slotnum
		
		-- sort the table
		for j = 1, bar.count do
	
			bagnum = bar.item[j].bag;
			slotnum = bar.item[j].slot;
			
			i = self.db.account.cache.who[current_user].loc[loc_id].bag[bagnum].slot[slotnum]
		
		
			-- default sort by bag then slot
			bar.item[j]["sort"] = format( "%04i", bagnum ) .. " " .. format( "%04i", slotnum );
		
			-- set sort key
			if self.db.profile.option.sort.type == ARKINV_G.SLOT_SORT_NAME then
				-- name, bag_type, bag, slot

				if i.name == "" then
					-- sort the empty slots by type
					t = self.db.account.cache.who[current_user].loc[loc_id].bag[bagnum].type
				else
					t = 0
				end


				bar.item[j].sort = i.name .. " " .. format( "%04i", t ) .. " " .. format( "%04i", i.count ) .. bar.item[j].sort

			end

			
			if self.db.profile.option.sort.quality then
				-- add rarity to start of sort
				bar.item[j].sort = format( "%02i", i.q ) .. " " .. bar.item[j].sort;
			end
				


			
		end
	
		sort( bar.item, function( a, b ) return a.sort > b.sort end );
	
	end


	
	local pad_slot = self.db.profile.option.slot.pad
	local pad_bar = self.db.profile.option.bar.pad
	local col = bar.width
	local obj, locked, readable, bnum
	
	-- build the items in the bar
	for j = 1, bar.count do
	
		bnum = j + button_offset
		i = self.db.account.cache.who[current_user].loc[loc_id].bag[bar.item[j].bag].slot[bar.item[j].slot]
		
		name = parent .. "Item" .. bnum
		obj = getglobal( name );
		
		if ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD then

			getglobal( obj:GetName() .. "ArkBag" ):SetID( bar.item[j].bag )
			getglobal( obj:GetName() .. "ArkSlot" ):SetID( bar.item[j].slot )
		
			-- anchor first item to bar frame
			if ( j == 1 ) then
				obj:SetPoint( "BOTTOMRIGHT", bar_frame, "BOTTOMRIGHT", 0 - pad_slot - ARKINV_G.WINDOW_OFFSET, pad_slot + ARKINV_G.WINDOW_OFFSET );
			else
				if ( mod( ( j - 1 ), col ) == 0 ) then
					-- next row, place above first item in previous row
					obj:SetPoint( "BOTTOMRIGHT", parent .. "Item" .. ( bnum - col ), "TOPRIGHT", 0, pad_slot );
				else
					-- place next to last one
					obj:SetPoint( "BOTTOMRIGHT", parent .. "Item" .. ( bnum - 1 ), "BOTTOMLEFT", 0 - pad_slot, 0 );
				end
			end
	
			SetItemButtonTexture( obj, i.texture );
		
		end
		
		

		SetItemButtonCount( obj, i.count );
	
		-- item locked, needs to only happen for online items
		if not ARKINV_G.LOCATION[loc_id].OFFLINE then
			_, _, locked, _, readable = GetContainerItemInfo( bar.item[j].bag, bar.item[j].slot );
			obj.readable = readable;
			SetItemButtonDesaturated( obj, locked, 0.5, 0.5, 0.5 );
		else
			obj.readable = false;
		end

		
		-- item rarity coloured borders
		if i.q > 0 and self.db.profile.option.slot.border then
			local r, g, b = GetItemQualityColor( i.q );
			getglobal( obj:GetName() .. "Ark" ):SetBackdropBorderColor( r, g, b, 1 );
		else
			getglobal( obj:GetName() .. "Ark" ):SetBackdropBorderColor( 0.5, 0.5, 0.5, 1 );
		end

		
		if ARKINV_G.LOCATION[loc_id].OFFLINE and self.db.profile.option.slot.fade then
			obj:SetAlpha( ARKINV_G.FADE_ALPHA );
		else
			obj:SetAlpha( 1 );
		end
		
		
		if ( i.texture ) then
			
			getglobal( obj:GetName() .. "ArkBackground" ):SetTexture( 0, 0, 0, 0 );
				
			self:UpdateCooldown( obj );
			obj.hasItem = 1;
	
		else
				
			getglobal( obj:GetName() .. "Cooldown"):Hide();
			obj.hasItem = nil;
			
			if self.db.profile.option.slot.empty.icon then
			
				-- icon background
				getglobal( obj:GetName() .. "ArkBackground" ):SetTexture( "Interface\\Buttons\\UI-EmptySlot-White" );
				getglobal( obj:GetName() .. "ArkBackground" ):SetTexCoord( 0.17, 0.83, 0.17, 0.83 );
			
			else
			
				-- slot background colour
				local bt = self.db.account.cache.who[current_user].loc[loc_id].bag[bar.item[j].bag].type;
				local colour = self.db.profile.option.slot.data[bt].colour
				
				getglobal( obj:GetName() .. "ArkBackground" ):SetTexture( colour.r, colour.g, colour.b, 0.25 )
					
			end
				
		end

		obj:Show();
	
	end

	
	
	local mem = gcinfo() - mem;
	
	--self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " GenerateItems() end - " .. mem )
	
end

function ARKINV:GenerateBarBorder( name )

	local loc_id = self:UiLocationID( name );
	
	local current_user = ARKINV_G.LOCATION[loc_id].USER;

	for rownum, row in ipairs( self.db.account.cache.who[current_user].loc[loc_id].container.row ) do
		for barnum, bar in ipairs( row.bar ) do
			obj = getglobal( name .. "Bar" .. bar.frame );
			
			if self.db.profile.option.bar.border then
				obj:SetBackdropBorderColor( self.db.profile.option.bar.colour.border.r, self.db.profile.option.bar.colour.border.g, self.db.profile.option.bar.colour.border.b, 1 );
			else
				obj:SetBackdropBorderColor( 0, 0, 0, 0 )
			end
			
			if ARKINV_G.MODE_EDIT then
				obj:SetBackdropBorderColor( 1, 0, 0, 1 );
				getglobal( obj:GetName() .. "Background" ):SetTexture( 1, 0, 0, 0.1 );
				getglobal( obj:GetName() .. "Edit" ):Show();
			else
				getglobal( obj:GetName() .. "Background" ):SetTexture( self.db.profile.option.bar.colour.background.r, self.db.profile.option.bar.colour.background.g, self.db.profile.option.bar.colour.background.b, self.db.profile.option.bar.colour.background.a );
			end
			
			obj:Show();
		end
	end
	
end



function ARKINV:GenerateContainerRebuildAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:GenerateContainerRebuild( loc_id );
	end
end

function ARKINV:GenerateContainerRebuild( loc_id )
	ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD = true;
	ARKINV_G.LOCATION[loc_id].WINDOW.REFRESH = true;
	self:GenerateContainerActual( loc_id );
end


function ARKINV:GenerateContainerRefreshAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:GenerateContainerRefresh( loc_id );
	end
end

function ARKINV:GenerateContainerRefresh( loc_id )
	ARKINV_G.LOCATION[loc_id].WINDOW.REFRESH = true;
	self:GenerateContainerActual( loc_id );
end


function ARKINV:GenerateContainerAll()
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		self:GenerateContainerActual( loc_id );
	end
end

function ARKINV:GenerateContainerActual( loc_id )

	self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " GenerateContainer( " .. loc_id .. " ) start" );
	
	local mem = gcinfo();
	
	
	local frame = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "Container" )
		
	local current_user = ARKINV_G.LOCATION[loc_id].USER;
	

	-- exit if window isn't displayed
	if not frame:IsVisible() then
		self:Debug( date() .. " GenerateContainer( " .. loc_id .. " ) aborted, not visible" );
		return
	end

	
	-- are we online or offline?
	if current_user == ARKINV_G.ME then
		ARKINV_G.LOCATION[loc_id].OFFLINE = false;
		if loc_id == ARKINV_G.LOCATION_BANK and ARKINV_G.MODE_BANK == false then
			ARKINV_G.LOCATION[loc_id].OFFLINE = true;
		end
	else
		ARKINV_G.LOCATION[loc_id].OFFLINE = true;
	end


	-- rescan all bags
	if not ARKINV_G.LOCATION[loc_id].OFFLINE then
		self:BagScanAll();
	end


	-- do we need to refresh or rebuild the window
	if not ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD and not ARKINV_G.LOCATION[loc_id].WINDOW.REFRESH then
		self:Debug( date() .. " GenerateContainer( " .. loc_id .. " ) aborted, no need" );
		return
	end



	
	local obj

	getglobal( ARKINV_G.GUI_NAME .. loc_id ):SetScale( self.db.profile.option.window.scale );

	-- set the alpha level (transparency) for all child frames
	for _, z in pairs( { getglobal( ARKINV_G.GUI_NAME .. loc_id ):GetChildren() } ) do
		obj = getglobal( z:GetName() .. "Background" );
		if obj then
			obj:SetTexture( self.db.profile.option.window.colour.background.r, self.db.profile.option.window.colour.background.g, self.db.profile.option.window.colour.background.b, self.db.profile.option.window.colour.background.a );
		end
	end


	-- setup main icon
	getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleLocation0" ):SetNormalTexture( ARKINV_G.LOCATION[loc_id].TEXTURE );
	
	-- setup small icons
	for x in pairs( ARKINV_G.LOCATION ) do
		obj = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleLocation" .. x );
		obj:SetNormalTexture( ARKINV_G.LOCATION[x].TEXTURE );
		obj:SetPushedTexture( ARKINV_G.LOCATION[x].TEXTURE );
		obj:SetDisabledTexture( ARKINV_G.LOCATION[x].TEXTURE );
		obj:SetHighlightTexture( ARKINV_G.LOCATION[x].TEXTURE );
		
	end

	--set program name text
	local t = ARKINV_G.PROGRAM_NAME .. " v" .. format( "%.2f", ARKINV_G.PROGRAM_VERSION );
	if ARKINV_G.PROGRAM_BETA then
		t = t .. " (beta " .. ARKINV_G.PROGRAM_BETA .. ")";
	end
	getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleProgram" ):SetText( t );
	
	-- set the current user
	obj = getglobal( ARKINV_G.GUI_NAME .. loc_id .. "TitleWho" );
	t = current_user;
	if ARKINV_G.LOCATION[loc_id].OFFLINE then
		obj:SetTextColor( 1, 0, 0 );
		t = strmatch( current_user, "(.+) %- " ) .. " [" .. ARKINV_L["STATUS_OFFLINE"] .. "] - " .. strmatch( current_user, " %- (.+)" );
	else
		obj:SetTextColor( 0, 1, 0 );
	end
	obj:SetText( t .. " - " .. ARKINV_G.LOCATION[loc_id].NAME );


	
	if ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD then

	
	
		-- break the inventory up into it's respective bars
		self:CalculateBars( loc_id );

		-- calculate what the container should look like
		self:CalculateContainer( loc_id );

		local name
	
	
		-- create (if required) the bar frames, and hide any that are no longer required
		for j = 1, ARKINV_G.LOCATION[loc_id].BAR_MAX do
			name = frame:GetName() .. "Bar" .. j;
			obj = getglobal( name );
			if not obj then
				obj = CreateFrame( "Frame", name, frame, "ARVINVFrameBar" );
			end
			getglobal( name .. "Edit" ):Hide();
			obj:Hide();
		end

		-- calculate numer of active slots
		self.db.account.cache.who[current_user].loc[loc_id].slot_count = self:tableSum( self.db.account.cache.who[current_user].loc[loc_id].bag, function( a ) return a.count; end );

		-- check the maximum number of slots used so far this session
		if self.db.account.cache.who[current_user].loc[loc_id].slot_count > ARKINV_G.LOCATION[loc_id].SLOT_MAX then
			ARKINV_G.LOCATION[loc_id].SLOT_MAX = self.db.account.cache.who[current_user].loc[loc_id].slot_count;
		end
		
		-- create (if required) the item buttons, and hide any that are no longer required
		for j = 1, ARKINV_G.LOCATION[loc_id].SLOT_MAX do
			name = frame:GetName() .. "Item" .. j
			obj = getglobal( name );
				
			if not obj then
				obj = CreateFrame( "Button", name, frame, "ARKINV_ItemButtonTemplate" );
				
				if j == 1 then
					ARKINV_G.BAG_SLOT_SIZE = obj:GetWidth();
				end
				
			end

			if ARKINV_G.MODE_EDIT or ARKINV_G.LOCATION[loc_id].OFFLINE then
				-- disable clicks/drag when in edit mode or offline
				obj:RegisterForClicks();
				obj:RegisterForDrag();
			else
				obj:RegisterForClicks( "LeftButtonUp", "RightButtonUp" );
				obj:RegisterForDrag( "LeftButton" );
			end

			getglobal( obj:GetName() .. "ArkBag" ):SetID( 999 )
			getglobal( obj:GetName() .. "ArkSlot" ):SetID( 999 )
			
			obj:Hide();
			
		end
	

		-- anchor the bar frames
		local pad_slot = self.db.profile.option.slot.pad
		local pad_bar = self.db.profile.option.bar.pad
		local rmw = 0 -- row max width - each row is not the same width and we need to use the largest when sizing the main window
	
		self.db.account.cache.who[current_user].loc[loc_id].container.width = 0;
		self.db.account.cache.who[current_user].loc[loc_id].container.height = ARKINV_G.WINDOW_OFFSET * 2;

		name = frame:GetName()
	
		for rownum, row in ipairs( self.db.account.cache.who[current_user].loc[loc_id].container.row ) do
	
			rmw = ARKINV_G.WINDOW_OFFSET * 2;
		
			for barnum, bar in ipairs( row.bar ) do

				obj = getglobal( name .. "Bar" .. bar.frame );
				obj:SetID( bar.id )
				
				-- self:Debug( "row=" .. rownum .. ", bar=" .. barnum .. ", obj=" .. obj:GetName() .. ", frame=" .. bar.frame )

				-- anchor first bar to frame
				if ( bar.frame == 1 ) then
					obj:SetPoint( "BOTTOMRIGHT", name, "BOTTOMRIGHT", 0 - ARKINV_G.WINDOW_OFFSET, ARKINV_G.WINDOW_OFFSET );
				else
					if ( barnum == 1 ) then
						-- next row, place under previous row
						-- self:Debug( "anchor=" .. name .. "Bar" .. self.db.account.cache.who[current_user].loc[loc_id].container.row[rownum-1].bar[1].frame )
						obj:SetPoint( "BOTTOMRIGHT", name .. "Bar" .. self.db.account.cache.who[current_user].loc[loc_id].container.row[rownum-1].bar[1].frame, "TOPRIGHT", 0, pad_bar );
					else
						-- next slot, place icon nxt to last one
						obj:SetPoint( "BOTTOMRIGHT", name .. "Bar" .. ( bar.frame - 1 ), "BOTTOMLEFT", 0 - pad_bar, 0 );
					end
				
				end
	
				obj:SetWidth( bar.width * ARKINV_G.BAG_SLOT_SIZE + ( bar.width + 1 ) * pad_slot + ARKINV_G.WINDOW_OFFSET * 2 );
				rmw = rmw + obj:GetWidth();
				if barnum > 1 then
					rmw = rmw + pad_bar
				end
				
				obj:SetHeight( bar.height * ARKINV_G.BAG_SLOT_SIZE + ( bar.height + 1 ) * pad_slot + ARKINV_G.WINDOW_OFFSET * 2 );
				
			end

			if rmw > self.db.account.cache.who[current_user].loc[loc_id].container.width then
				self.db.account.cache.who[current_user].loc[loc_id].container.width = rmw
			end
		
			self.db.account.cache.who[current_user].loc[loc_id].container.height = self.db.account.cache.who[current_user].loc[loc_id].container.height + obj:GetHeight()

		end

		local x = ( self:tableElements( self.db.account.cache.who[current_user].loc[loc_id].container.row ) or 0 ) - 1
		if x > 0 then
			self.db.account.cache.who[current_user].loc[loc_id].container.height = self.db.account.cache.who[current_user].loc[loc_id].container.height + pad_bar * x;
		end

	end
	
	

	-- display bar borders if required
	self:GenerateBarBorder( frame:GetName() );
	
	
	-- display item icons
	local button_offset = 0
	for rownum, row in ipairs( self.db.account.cache.who[current_user].loc[loc_id].container.row ) do
		for barnum, bar in ipairs( row.bar ) do
			obj = getglobal( frame:GetName() .. "Bar" .. bar.frame );
			self:GenerateItems( bar, obj, button_offset );
			button_offset = button_offset + bar.count;
		end
	end

	
	if ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD then	
	
		if self.db.account.cache.who[current_user].loc[loc_id].container.height < 40 then
			self.db.account.cache.who[current_user].loc[loc_id].container.height = 40
		end
		
		if self.db.account.cache.who[current_user].loc[loc_id].container.width < 450 then
			self.db.account.cache.who[current_user].loc[loc_id].container.width = 450
		end
		
		frame:SetWidth( self.db.account.cache.who[current_user].loc[loc_id].container.width )
		frame:SetHeight( self.db.account.cache.who[current_user].loc[loc_id].container.height )

		self:FrameUpdate( loc_id );
		
	end
	
	


	ARKINV_G.LOCATION[loc_id].WINDOW.REBUILD = false;
	ARKINV_G.LOCATION[loc_id].WINDOW.REFRESH = false;
	
	local mem = gcinfo() - mem;
	
	self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " GenerateContainer( " .. loc_id .. " ) end - " .. mem );
	
end


function ARKINV:ItemButton_OnEnter( button )

	--self:Debug( "onenter, previous, bag=" .. this:GetParent():GetID() .. ", slot=" .. this:GetID() .. ", button=" .. this:GetName() );

	bagnum = getglobal( button:GetName() .. "ArkBag" ):GetID();
	slotnum = getglobal( button:GetName() .. "ArkSlot" ):GetID();

	button:GetParent():SetID( bagnum );
	button:SetID( slotnum );

	--self:Debug( "onenter: bag=" .. bagnum .. ", slot=" ..slotnum .. ", button=" .. this:GetName() );
	
	-- build tooltip because the blizzard template wont work with offline data
	
	loc_id = ARKINV:UiLocationID( button:GetName() );
	if not loc_id then
		return false
	end

	local current_user = ARKINV_G.LOCATION[loc_id].USER;
	
	local usemytooltip = false;

	local i = self.db.account.cache.who[current_user].loc[loc_id].bag[bagnum].slot[slotnum]
	
	if ( ( i.h ) and ( ARKINV_G.LOCATION[loc_id].OFFLINE or bagnum == -1 or bagnum == -2 or ARKINV_G.MODE_EDIT ) ) then

		usemytooltip = true;
	
		local x;
		x = button:GetRight();
		if ( x >= ( GetScreenWidth() / 2 ) ) then
			GameTooltip:SetOwner( button, "ANCHOR_LEFT" );
		else
			GameTooltip:SetOwner( button, "ANCHOR_RIGHT" );
		end

		if ARKINV_G.LOCATION[loc_id].OFFLINE then
			-- offline, build tooltip from itemlink
			local s = strmatch( i.h, "(item:%d+:%d+:%d+:%d+:%d+:%d+:%d+:%d+)" );
			GameTooltip:SetHyperlink( s );
		elseif bagnum == -1 then
			-- bank slot
			GameTooltip:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) );
		elseif bagnum == -2 then
			-- keyring slot
			GameTooltip:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) );
		elseif ARKINV_G.MODE_EDIT then
			GameTooltip:SetBagItem( bagnum, slotnum );
		end

		GameTooltip:Show();
		
	end
	
	return usemytooltip;
	
end


function ARKINV:UpdateCooldown( obj )

	bag = getglobal( obj:GetName() .. "ArkBag" ):GetID();
	slot = getglobal( obj:GetName() .. "ArkSlot" ):GetID();
	
	local cooldown = getglobal( obj:GetName() .. "Cooldown" );
	local start, duration, enable = GetContainerItemCooldown( bag, slot );
	CooldownFrame_SetTimer( cooldown, start, duration, enable );
	if ( duration > 0 and enable == 0 ) then
		SetItemButtonTextureVertexcolour( obj, 0.4, 0.4, 0.4 );
	end
	
end


function ARKINV:ItemCategoryID( cat )

	-- self:Debug( "ItemCategoryID( " .. cat .. " )" );

	for _, v in pairs( ARKINV_G.CATEGORY ) do
		if cat == v.name then
			return v.id
		end
	end
	
	return 0 -- default
	
end


function ARKINV:ItemCategoryGetDefaultOverride( internal_id )

	local id = strmatch( internal_id, "^(%d+)." );
	if not id then
		return nil
	end
	


	local _, class = UnitClass( "player" );

	-- check class override
	if ARKINV_DEFAULT_CATEGORY_OVERRIDES[id .. "." .. class] then
		return self:ItemCategoryID( ARKINV_L[ARKINV_DEFAULT_CATEGORY_OVERRIDES[id .. "." .. class]] );
	end
	
	-- check profession override
	-- how do i get a list of the players professions?

	-- default over-ride (check hard coded list of obvious defaults)
	if ARKINV_DEFAULT_CATEGORY_OVERRIDES[id] then
		return self:ItemCategoryID( ARKINV_L[ARKINV_DEFAULT_CATEGORY_OVERRIDES[id]] );
	else
		return nil;
	end

end


function ARKINV:ItemCategoryGetDefault( i, bt, bagnum, slotnum )
	
	if not ( i.h ) then
		-- empty slot
		
		-- self:Debug( "ItemCategoryGetDefault( nil, " .. bt .. " )" )

		local clump = self.db.profile.option.slot.empty.clump
		
		if bt == ARKINV_G.SLOT_BAG then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_BAG"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_PROJECTILE_BULLET then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_BULLET"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_PROJECTILE_BULLET"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_PROJECTILE_ARROW then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_ARROW"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_PROJECTILE_ARROW"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_KEY then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_KEY"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_KEY"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_SOULSHARD then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULSHARD"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_SOULSHARD"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_HERB then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_HERBALISM"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_HERB"] )
			end
						
		end
		
		if bt == ARKINV_G.SLOT_ENCHANTING then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_ENCHANTING"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_ENGINEERING then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_ENGINEERING"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_GEM then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_GEM"] )
			end
			
		end
		
		if bt == ARKINV_G.SLOT_MINING then
		
			if clump then
				return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_MINING"] )
			else
				return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_MINING"] )
			end
		
		end
		
		return self:ItemCategoryID( ARKINV_L["CATEGORY_EMPTY_UNKNOWN"] )

	end
	

	local n, _, q, _, _, t, s = GetItemInfo( i.h )
	
	-- self:Debug( "ItemCategoryGetDefault( " .. h .. ", " .. bt .. " ) t=" .. t .. ", s=" .. s, "00ff00" )

	-- does it have a system default category override?
	local dco = self:ItemCategoryGetDefaultOverride( i.id )
	if dco then
		return dco
	end
	
	-- trash
	if q == 0 then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_TRASH"] )
	end
		
	-- basic item types!!!
	if t == ARKINV_L["ITEM_PROJECTILE"] then
	
		if s == ARKINV_L["ITEM_PROJECTILE_BULLET"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_BULLET"] )
		elseif s == ARKINV_L["ITEM_PROJECTILE_ARROW"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE_ARROW"] )
		end

		return self:ItemCategoryID( ARKINV_L["CATEGORY_PROJECTILE"] )
		
	end
	

	if t == ARKINV_L["ITEM_QUEST"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_QUEST"] )
	end
		
		
	if t == ARKINV_L["ITEM_RECIPE"] then
	
		if s == ARKINV_L["ITEM_PROFESSION_ALCHEMY"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ALCHEMY"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_BLACKSMITHING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_BLACKSMITHING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_COOKING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_COOKING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_ENCHANTING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_ENGINEERING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_FIRST_AID"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_FIRST_AID"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_JEWELCRAFTING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_LEATHERWORKING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_LEATHERWORKING"] )
		elseif s == ARKINV_L["ITEM_PROFESSION_TAILORING"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_TAILORING"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_RECIPE"] )
		end
		
	end


	-- tooltip scanning
	if self:IsTooltipReliable( bagnum ) == false then
		-- offline, build tooltip from itemlink
		local s = strmatch( i.h, "(item:%d+:%d+:%d+:%d+:%d+:%d+:%d+:%d+)" );
		gt:SetHyperlink( s );
	elseif bagnum == -1 then
		-- bank slot
		gt:SetInventoryItem( "player", BankButtonIDToInvSlotID( slotnum ) );
	elseif bagnum == -2 then
		-- keyring slot
		gt:SetInventoryItem( "player", KeyRingButtonIDToInvSlotID( slotnum ) );
	else
		gt:SetBagItem( bagnum, slotnum );
	end

	
	if i.sb or gt:Find( ARKINV_L["TOOLTIP_SOULBOUND"] ) then
		
		self:Debug( "soulbound default, bag=" .. bagnum .. ", slot=" .. slotnum .. ", id=" .. i.id .. ", link=" .. i.h );
		
		if t == ARKINV_L["ITEM_ARMOR"] or t == ARKINV_L["ITEM_WEAPON"] then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULBOUND_EQUIPMENT"] )
		else
			return self:ItemCategoryID( ARKINV_L["CATEGORY_SOULBOUND"] )
		end
		
	end

	-- non soulbound weapons and armour
	if t == ARKINV_L["ITEM_ARMOR"] or t == ARKINV_L["ITEM_WEAPON"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_EQUIPMENT"] );
	end

	-- non soulbound mounts
	if gt:Find( ARKINV_L["TOOLTIP_MOUNT"] ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_MOUNT"] )
	end

	
	if gt:Find( ARKINV_L["TOOLTIP_PET"] ) then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_PET_NONCOMBAT"] )
	end

		
	
	
	-- profession
	local req = gt:GetLine( 2 )
	if req and strfind( req, ARKINV_L["ITEM_REQUIRES"] ) then
	
		if strfind( req, ARKINV_L["ITEM_PROFESSION_ALCHEMY"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ALCHEMY"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_BLACKSMITHING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_BLACKSMITHING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_COOKING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_COOKING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_ENCHANTING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENCHANTING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_ENGINEERING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_ENGINEERING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_FIRST_AID"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_FIRST_AID"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_FISHING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_FISHING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_HERBALISM"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_HERBALISM"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_JEWELCRAFTING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_JEWELCRAFTING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_LEATHERWORKING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_LEATHERWORKING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_MINING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_MINING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_SKINNING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_SKINNING"] )
		elseif strfind( req, ARKINV_L["ITEM_PROFESSION_TAILORING"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_PROFESSION_TAILORING"] )
		end
		
	end


	-- class
	if gt:Find( ARKINV_L["TOOLTIP_CLASS"] ) then

		if gt:Find( ARKINV_L["TOOLTIP_CLASS_DRUID"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_DRUID"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_HUNTER"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_HUNTER"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_MAGE"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_MAGE"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_PALADIN"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_PALADIN"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_PRIEST"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_PRIEST"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_ROGUE"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_ROGUE"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_SHAMAN"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_SHAMAN"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_WARLOCK"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_WARLOCK"] )
		elseif gt:Find( ARKINV_L["TOOLTIP_CLASS_WARRIOR"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_CLASS_WARRIOR"] )
		end

	end
	

	-- consumable
	if t == ARKINV_L["ITEM_CONSUMABLE"] then
	
		if gt:Find( ARKINV_L["TOOLTIP_HEALPOT"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_HEALPOT"] )
		end
		
		if gt:Find( ARKINV_L["TOOLTIP_MANAPOT"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_MANAPOT"] )
		end
		
		if gt:Find( ARKINV_L["TOOLTIP_FOOD"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_FOOD"] )
		end
		
		if gt:Find( ARKINV_L["TOOLTIP_DRINK"] ) then
			return self:ItemCategoryID( ARKINV_L["CATEGORY_DRINK"] )
		end

		return self:ItemCategoryID( ARKINV_L["CATEGORY_CONSUMABLE"] );
	end
	
	if t == ARKINV_L["ITEM_KEY"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_KEY"] );
	end

	if t == ARKINV_L["ITEM_MISCELLANEOUS"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_MISCELLANEOUS"] );
	end

	if t == ARKINV_L["ITEM_REAGENT"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_REAGENT"] );
	end

	if t == ARKINV_L["ITEM_TRADE_GOODS"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_TRADE_GOODS"] );
	end

	if t == ARKINV_L["ITEM_CONTAINER"] then
		return self:ItemCategoryID( ARKINV_L["CATEGORY_CONTAINER"] );
	end


	-- fallback for any item not categorised
	return self:ItemCategoryID( ARKINV_L["CATEGORY_DEFAULT"] )
	
end


function ARKINV:ItemCategoryGet( i, bt, bagnum, slotnum )
	
	-- returns category, [ default category]
	
	--self:Debug( "ItemCategoryGet() start" )
	
	if not i.h then
	
		--self:Debug( "empty slot" )
		-- empty slot
		return self:ItemCategoryGetDefault( i, bt, bagnum, slotnum ), nil

	end
	
	-- self:Debug( "ItemCategoryGet( " .. h .. ", " .. bt .. " )" )
	-- check overrides
	
	if self.db.profile.option.category.item[i.id] then  -- k is a string, not a number
		return self.db.profile.option.category.item[i.id], self:ItemCategoryGetDefault( i, bt, bagnum, slotnum )
	end
	
	-- return default
	return self:ItemCategoryGetDefault( i, bt, bagnum, slotnum ), nil

	--self:Debug( "ItemCategoryGet() end" )
	
end


function ARKINV:ItemCategorySet( tblItem, category_id )
	-- set cat to nil to reset
	self.db.profile.option.category.item[tblItem.id] = category_id
	self:ItemCategoryReload( tblItem )
end


function ARKINV:ItemCategoryReload( tblItem )

	--self:Debug( "ItemCategoryReload() start" );

	local c = nil;
	local cd = nil;
	
	if tblItem.id then
		for name, who in pairs( self.db.account.cache.who ) do
			for _, loc in pairs( who.loc ) do
				for bagnum, bag in pairs( loc.bag ) do
					for slotnum, slot in pairs( bag.slot ) do
						if slot.id == tblItem.id then
							if not c then
								-- only get the category for the first match, use the same values for the rest
								c, cd = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum );
							end
							slot["cat"] = c
							slot["catdef"] = cd
						end
					end
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReload() end" );
	
end


function ARKINV:ItemCategoryReloadEmpty()

	--self:Debug( "ItemCategoryReloadEmpty() start" );
	
	for name, who in pairs( self.db.account.cache.who ) do
		for _, loc in pairs( who.loc ) do
			for bagnum, bag in pairs( loc.bag ) do
				for slotnum, slot in pairs( bag.slot ) do
					if not slot.h then
						slot["cat"], slot["catdef"] = self:ItemCategoryGet( slot, bag.type, bagnum, slotnum )
					end
				end
			end
		end
	end
	
	--self:Debug( "ItemCategoryReloadEmpty() end" );
	
end


function ARKINV:BagLocation( id )

	if not id then
		self:Print( RED_FONT_COLOR_CODE .. "BagLocation(), nil passed" )
		return
	end
	
	for loc_id in pairs( ARKINV_G.LOCATION ) do
		for _, bagnum in pairs( ARKINV_G.LOCATION[loc_id].IDS ) do
			if bagnum == id then
				return loc_id;
			end
		end
	end

	self:Print( RED_FONT_COLOR_CODE .. "BagLocation( " .. id .. " ), value not coded" )
	return nil

end

function ARKINV:BagType( id )

	if id == -2 then
		return ARKINV_G.SLOT_KEY
	elseif id == -1 or id == 0 then
		return ARKINV_G.SLOT_BAG
	end

	local h = GetInventoryItemLink( "player", ContainerIDToInventoryID( id ) )
	
	if h then
	
		local t, s = select( 6, GetItemInfo( h ) )

		if t == ARKINV_L["ITEM_CONTAINER"] then
		
			if s == ARKINV_L["ITEM_CONTAINER_BAG"] then
				return ARKINV_G.SLOT_BAG
			elseif s == ARKINV_L["ITEM_CONTAINER_SOULSHARD"] then
				return ARKINV_G.SLOT_SOULSHARD
			elseif s == ARKINV_L["ITEM_CONTAINER_HERB"] then
				return ARKINV_G.SLOT_HERB
			elseif s == ARKINV_L["ITEM_CONTAINER_ENCHANTING"] then
				return ARKINV_G.SLOT_ENCHANTING
			elseif s == ARKINV_L["ITEM_CONTAINER_ENGINEERING"] then
				return ARKINV_G.SLOT_ENGINEERING
			elseif s == ARKINV_L["ITEM_CONTAINER_GEM"] then
				return ARKINV_G.SLOT_GEM
			elseif s == ARKINV_L["ITEM_CONTAINER_MINING"] then
				return ARKINV_G.SLOT_MINING
			end
			
		elseif t == ARKINV_L["ITEM_QUIVER"] then
		
			if s == ARKINV_L["ITEM_QUIVER_ARROW"] then
				return ARKINV_G.SLOT_PROJECTILE_ARROW
			elseif s == ARKINV_L["ITEM_QUIVER_BULLET"] then
				return ARKINV_G.SLOT_PROJECTILE_BULLET
			end
			
		end
	
		return ARKINV_G.SLOT_UNKNOWN;
	
	end

	-- empty bag slots
	return ARKINV_G.SLOT_BAG;
	
end


function ARKINV:OptionMenuOpen()

	if dd:IsOpen( this ) then
	
		dd:Close()
		
	else
	
		dd:Open( this,
			"point", "TOPLEFT",
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
			
					dd:AddLine( "text", "OPTIONS", "isTitle", true, "textHeight", 12 );

					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine(	"text", "Edit Mode",
						"tooltipTitle", "Edit Mode",
						"tooltipText", "toggles edit mode on and off so you can customise which items and categories are displayed on which bars",
						"checked", ARKINV_G.MODE_EDIT,
						"func", function()
							ARKINV_G.MODE_EDIT = not ARKINV_G.MODE_EDIT;
							dd:Close();
							self:GenerateContainerRebuildAll();
						end
					);

					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", "Window",
						"hasArrow", true,
						"value", "WINDOW"
					);
	
					dd:AddLine( "text", "Bars",
						"hasArrow", true,
						"value", "BAR"
					);
					
					dd:AddLine( "text", "Items",
						"hasArrow", true,
						"value", "ITEM"
					)
					
					dd:AddLine( "text", "Sorting",
						"hasArrow", true,
						"value", "SORT"
					);
					
					dd:AddLine( "text", "", "disabled", true );
					
					dd:AddLine( "text", "Custom categories",
						"hasArrow", true,
						"value", "CATEGORY"
					);
					
					dd:AddLine( "text", "Offline",
						"hasArrow", true,
						"value", "OFFLINE"
					);
					
				end

					
				if level == 2 then
				
					if value == "WINDOW" then
					
						dd:AddLine( "text", "WINDOW OPTIONS", "isTitle", true, "textHeight", 12 );

						dd:AddLine( "text", "", "disabled", true );
						dd:AddLine( "text", "Width",
							"tooltipTitle", "Width",
							"tooltipText", "number of columns to display",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self.db.profile.option.window.col,
							"sliderMin", 8,
							"sliderMax", 32,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self.db.profile.option.window.col then
									self.db.profile.option.window.col = v;
									self:GenerateContainerRebuildAll();
								end
							end
						);
						dd:AddLine( "text", "Auto open",
							"hasArrow", true,
							"value", "AUTO_OPEN"
						);
						dd:AddLine( "text", "Auto close",
							"hasArrow", true,
							"value", "AUTO_CLOSE"
						);
						dd:AddLine( "text", "Scale",
							"tooltipTitle", "Scale",
							"tooltipText", "scale the interface making it larger or smaller",
							"hasArrow", true,
							"hasSlider", true,
							"sliderIsPercent", true,
							"sliderValue", self.db.profile.option.window.scale,
							"sliderMin", .4,
							"sliderMax", 2,
							"sliderStep", .05,
							"sliderFunc", function( v )
								if v ~= self.db.profile.option.window.scale then
									self.db.profile.option.window.scale = v;
									for loc_id in pairs( ARKINV_G.LOCATION ) do
										getglobal( ARKINV_G.GUI_NAME .. loc_id ):SetScale( self.db.profile.option.window.scale );
									end
								end
							end
						);
						dd:AddLine( "text", "Background Colour",
							"hasColorSwatch", true,
							"hasOpacity", true,
							"r", self.db.profile.option.window.colour.background.r,
							"g", self.db.profile.option.window.colour.background.g,
							"b", self.db.profile.option.window.colour.background.b,
							"opacity", self.db.profile.option.window.colour.background.a,
							"colorFunc", function( r, g, b, a )
								self.db.profile.option.window.colour.background.r = r;
								self.db.profile.option.window.colour.background.g = g;
								self.db.profile.option.window.colour.background.b = b;
								self.db.profile.option.window.colour.background.a = a;
								self:GenerateContainerRefreshAll();
							end
						);
					
					end
					
					if value == "BAR" then
						
						dd:AddLine( "text", "BAR OPTIONS", "isTitle", true, "textHeight", 12 );

						dd:AddLine( "text", "", "disabled", true );
						dd:AddLine(	"text", "Per Row",
							"tooltipTitle", "Bars per Row",
							"tooltipText", "the number of bars to display in each row",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self.db.profile.option.bar.per,
							"sliderMin", 1,
							"sliderMax", 8,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self.db.profile.option.bar.per then
									self.db.profile.option.bar.per = v;
									self:GenerateContainerRebuildAll();
								end
							end
						);
						dd:AddLine( "text", "Padding",
							"tooltipTitle", "Bar Padding",
							"tooltipText", "the amount of space to add between bars",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self.db.profile.option.bar.pad,
							"sliderMin", 0,
							"sliderMax", 64,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if v ~= self.db.profile.option.bar.pad then
									self.db.profile.option.bar.pad = v;
									self:GenerateContainerRefreshAll();
								end
							end
						);
						dd:AddLine( "text", "Background Colour",
							"hasColorSwatch", true,
							"hasOpacity", true,
							"r", self.db.profile.option.bar.colour.background.r,
							"g", self.db.profile.option.bar.colour.background.g,
							"b", self.db.profile.option.bar.colour.background.b,
							"opacity", self.db.profile.option.bar.colour.background.a,
							"colorFunc", function( r, g, b, a )
								self.db.profile.option.bar.colour.background.r = r;
								self.db.profile.option.bar.colour.background.g = g;
								self.db.profile.option.bar.colour.background.b = b;
								self.db.profile.option.bar.colour.background.a = a;
								self:GenerateContainerRefreshAll();
							end
						);
						dd:AddLine( "text", "Border",
							"tooltipTitle", "Bar Borders",
							"tooltipText", "toggles the display of a border around each bar",
							"checked", self.db.profile.option.bar.border,
							"func", function()
								self.db.profile.option.bar.border = not self.db.profile.option.bar.border;
								self:GenerateContainerRefreshAll();
							end
						);
						if self.db.profile.option.bar.border then
							dd:AddLine( "text", "Border Colour",
								"hasColorSwatch", true,
								"r", self.db.profile.option.bar.colour.border.r,
								"g", self.db.profile.option.bar.colour.border.g,
								"b", self.db.profile.option.bar.colour.border.b,
								"colorFunc", function( r, g, b )
									self.db.profile.option.bar.colour.border.r = r;
									self.db.profile.option.bar.colour.border.g = g;
									self.db.profile.option.bar.colour.border.b = b;
									self:GenerateContainerRefreshAll();
								end
							);
						end
					
					end
					
					if value == "ITEM" then
					
						dd:AddLine( "text", "ITEM OPTIONS", "isTitle", true, "textHeight", 12 );

						dd:AddLine( "text", "", "disabled", true );
						dd:AddLine( "text", "Padding",
							"tooltipTitle", "Slot Padding",
							"tooltipText", "the amount of space to add between item slots",
							"hasArrow", true,
							"hasSlider", true,
							"sliderValue", self.db.profile.option.slot.pad,
							"sliderMin", 2,
							"sliderMax", 16,
							"sliderStep", 1,
							"sliderFunc", function( v )
								if self.db.profile.option.slot.pad ~= v then
									self.db.profile.option.slot.pad = v;
									self:GenerateContainerRebuildAll();
								end
							end
						);
						dd:AddLine( "text", "Coloured empty slots",
							"tooltipTitle", "Coloured empty slots",
							"tooltipText", "colour empty slot options",
							"hasArrow", self.db.profile.option.slot.empty.icon == false,
							"value", "EMPTY_COLOUR",
							"checked", self.db.profile.option.slot.empty.icon == false,
							"func", function()
								self.db.profile.option.slot.empty.icon = not self.db.profile.option.slot.empty.icon;
								self:GenerateContainerRefreshAll();
							end
						);
						dd:AddLine( "text", "Clump empty slots",
							"tooltipTitle", "Clump empty slots",
							"tooltipText", "toggles wether empty slots are clumped in together with their non-empty type slots or treated as a seperate category",
							"checked", self.db.profile.option.slot.empty.clump,
							"func", function()
								self.db.profile.option.slot.empty.clump = not self.db.profile.option.slot.empty.clump;
								self:ItemCategoryReloadEmpty();
								self:GenerateContainerRebuildAll();
							end
						);
						dd:AddLine( "text", "Fade offline items",
							"tooltipTitle", "Fade offline items",
							"tooltipText", "fades the items to grey when they are offline",
							"checked", self.db.profile.option.slot.fade,
							"func", function()
								self.db.profile.option.slot.fade = not self.db.profile.option.slot.fade;
								self:GenerateContainerRefreshAll();
							end
						);
						dd:AddLine( "text", "Rarity coloured border",
							"tooltipTitle", "Slot border colour",
							"tooltipText", "colour the border around each item slot to match it's rarity (Common, Rare, Epic, etc)",
							"checked", self.db.profile.option.slot.border,
							"func", function()
								self.db.profile.option.slot.border = not self.db.profile.option.slot.border;
								self:GenerateContainerRefreshAll();
							end
						);
						dd:AddLine( "text", "Show hidden categories",
							"tooltipTitle", "Show hidden",
							"tooltipText", "toggles wether hidden categories are shown or not",
							"checked", self.db.profile.option.window.ignorehidden,
							"func", function()
								self.db.profile.option.window.ignorehidden = not self.db.profile.option.window.ignorehidden;
								self:GenerateContainerRebuildAll();
							end
						);
		
					end
					
					if value == "SORT" then

						dd:AddLine( "text", "SORT OPTIONS", "isTitle", true, "textHeight", 12 );

						dd:AddLine( "text", "", "disabled", true );

						dd:AddLine( "text", "By Name",
							"isRadio", true,
							"checked", self.db.profile.option.sort.type == ARKINV_G.SLOT_SORT_NAME,
							"func", function()
								if self.db.profile.option.sort.type ~= ARKINV_G.SLOT_SORT_NAME then
									self.db.profile.option.sort.type = ARKINV_G.SLOT_SORT_NAME;
									self:GenerateContainerRebuildAll();
								end
							end
						);

						dd:AddLine( "text", "By Bag / Slot",
							"isRadio", true,
							"checked", self.db.profile.option.sort.type == ARKINV_G.SLOT_SORT_BAGSLOT,
							"func", function()
								if self.db.profile.option.sort.type ~= ARKINV_G.SLOT_SORT_BAGSLOT then
									self.db.profile.option.sort.type = ARKINV_G.SLOT_SORT_BAGSLOT;
									self:GenerateContainerRebuildAll();
								end
							end
						);


						dd:AddLine( "text", "", "disabled", true );
						dd:AddLine( "text", "Include rarity in sort",
							"tooltipTitle", "Include rarity in sort",
							"tooltipText", "toggles the sorting of items by rarity",
							"checked", self.db.profile.option.sort.quality,
							"func", function()
								self.db.profile.option.sort.quality = not self.db.profile.option.sort.quality;
								self:GenerateContainerRebuildAll();
							end
						);


						
					end
					
					if value == "CATEGORY" then
					
						dd:AddLine( "text", "CUSTOM CATEGORY OPTIONS", "isTitle", true, "textHeight", 12 );

						dd:AddLine( "text", "", "disabled", true );
						dd:AddLine( "text", "Add new category",
							"hasArrow", true,
							"hasEditBox", true,
							"editBoxFunc", function( v )
								self:CategoryCustomAdd( v );
							end
						);
						
						dd:AddLine( "text", "", "disabled", true );
						for k, v in self:spairs( self.db.profile.option.category.custom, function(a,b) return self.db.profile.option.category.custom[a] < self.db.profile.option.category.custom[b] end ) do
							dd:AddLine( "text", v,
								"hasArrow", true,
								"value", ( "CATEGORYCUSTOM" .. k )
							);
						end
					end
					
					if value == "OFFLINE" then

						dd:AddLine( "text", "OFFLINE OPTIONS", "isTitle", true, "textHeight", 12 );

						dd:AddLine( "text", "", "disabled", true );
						dd:AddLine( "text", "Bags & Keyring",
							"tooltipTitle", "Bags & Keyring",
							"tooltipText", "remember bag and keyring data so you can view it while on another character.  change will take effect next login/logout",
							"checked", self.db.profile.option.offline.alt,
							"func", function()
								self.db.profile.option.offline.alt = not self.db.profile.option.offline.alt;
							end
						);
						dd:AddLine( "text", "Bank",
							"tooltipTitle", "Bank",
							"tooltipText", "remember bank data so you can view it while 'offline'.  change will take effect next login/logout",
							"checked", self.db.profile.option.offline.bank,
							"func", function()
								self.db.profile.option.offline.bank = not self.db.profile.option.offline.bank;
							end
						);

					
					end
					
				end
				
				if level == 3 then
				
					if value == "AUTO_OPEN" then

						dd:AddLine( "text", "Bank",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open the bank",
							"checked", self.db.profile.option.window.auto.open.bank,
							"func", function()
								self.db.profile.option.window.auto.open.bank = not self.db.profile.option.window.auto.open.bank;
							end
						);
						dd:AddLine( "text", "Mailbox",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open the mailbox",
							"checked", self.db.profile.option.window.auto.open.mail,
							"func", function()
								self.db.profile.option.window.auto.open.mail = not self.db.profile.option.window.auto.open.mail;
							end
						);
						dd:AddLine( "text", "Merchant",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you talk to a merchant",
							"checked", self.db.profile.option.window.auto.open.merchant,
							"func", function()
								self.db.profile.option.window.auto.open.merchant = not self.db.profile.option.window.auto.open.merchant;
							end
						);
						dd:AddLine( "text", "Trade",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open a trade",
							"checked", self.db.profile.option.window.auto.open.trade,
							"func", function()
								self.db.profile.option.window.auto.open.trade = not self.db.profile.option.window.auto.open.trade;
							end
						);
						dd:AddLine( "text", "Auction House",
							"tooltipTitle", "Auto Open",
							"tooltipText", "toggles wether the window is automatically opened when you open the auction house",
							"checked", self.db.profile.option.window.auto.open.auction,
							"func", function()
								self.db.profile.option.window.auto.open.auction = not self.db.profile.option.window.auto.open.auction;
							end
						);
					
					end
					
					if value == "AUTO_CLOSE" then
					
						dd:AddLine( "text", "Bank",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave the bank",
							"checked", self.db.profile.option.window.auto.close.bank,
							"func", function()
								self.db.profile.option.window.auto.close.bank = not self.db.profile.option.window.auto.close.bank;
							end
						);
						dd:AddLine( "text", "Mailbox",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave the mailbox",
							"checked", self.db.profile.option.window.auto.close.mail,
							"func", function()
								self.db.profile.option.window.auto.close.mail = not self.db.profile.option.window.auto.close.mail;
							end
						);
						dd:AddLine( "text", "Merchant",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave a merchant",
							"checked", self.db.profile.option.window.auto.close.merchant,
							"func", function()
								self.db.profile.option.window.auto.close.merchant = not self.db.profile.option.window.auto.close.merchant;
							end
						);
						dd:AddLine( "text", "Trade",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you close a trade",
							"checked", self.db.profile.option.window.auto.close.trade,
							"func", function()
								self.db.profile.option.window.auto.close.trade = not self.db.profile.option.window.auto.close.trade;
							end
						);
						dd:AddLine( "text", "Auction House",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you leave the auction house",
							"checked", self.db.profile.option.window.auto.close.auction,
							"func", function()
								self.db.profile.option.window.auto.close.auction = not self.db.profile.option.window.auto.close.auction;
							end
						);
						dd:AddLine( "text", "Combat",
							"tooltipTitle", "Auto Close",
							"tooltipText", "toggles wether the window is automatically closed when you enter combat",
							"checked", self.db.profile.option.window.auto.close.combat,
							"func", function()
								self.db.profile.option.window.auto.close.combat = not self.db.profile.option.window.auto.close.combat;
							end
						);
						
					end
					
					if value == "EMPTY_COLOUR" then
					
						dd:AddLine( "text", "EMPTY SLOT COLOURS", "isTitle", true, "textHeight", 12 );
						dd:AddLine( "text", "", "disabled", true );
						
						for k, v in self:spairs( self.db.profile.option.slot.data, function(a,b) return self.db.profile.option.slot.data[a].long < self.db.profile.option.slot.data[b].long end ) do
							dd:AddLine( "text", v.long,
								"hasColorSwatch", true,
								"r", self.db.profile.option.slot.data[k].colour.r,
								"g", self.db.profile.option.slot.data[k].colour.g,
								"b", self.db.profile.option.slot.data[k].colour.b,
								"colorFunc", function( r, g, b )
									self.db.profile.option.slot.data[k].colour.r = r;
									self.db.profile.option.slot.data[k].colour.g = g;
									self.db.profile.option.slot.data[k].colour.b = b;
									self:GenerateContainerRefreshAll();
								end
							);
						end

						dd:AddLine( "text", "", "disabled", true );
						dd:AddLine( "text", "Reset to defaults",
							--"disabled", true,
							"func", function()
								dd:Close();
								self.db.profile.option.slot.data = nil;
							end
						);
						
					end

					if value and string.sub( value, 1, 14 ) == "CATEGORYCUSTOM" then
						
						local cat_id = tonumber( strmatch( value, "CATEGORYCUSTOM(.+)" ) );
						local cat_name = strmatch( self:GetCategoryName( cat_id ), ARKINV_L["CATEGORY_CUSTOM"] .. ": (.*)" );
						
						--!!!!
						dd:AddLine( "text", "Rename " .. cat_name .. " to",
							"hasArrow", true,
							"hasEditBox", true,
							"editBoxText", cat_name,
							"editBoxFunc", function( v )
								self:CategoryCustomRename( cat_id, v );
							end
						);


						dd:AddLine( "text", "Delete " .. cat_name,
							"tooltipTitle", "Delete a custom category",
							"tooltipText", "deletes a custom category.  you must enter the word 'confirm' to actually delete the category",
							"hasArrow", true,
							"hasEditBox", true,
							"editBoxFunc", function( v )
								self:CategoryCustomDelete( cat_id, v );
							end
						);
						
						
					end
				
				end
				
			end
			
		)

	end
	
end


function ARKINV:BarMenuOpen()

	if dd:IsOpen( this ) then

		dd:Close()
		
	else

		local barnum = this:GetParent():GetID();
		
		local cat_type = {
			[1] = "SYSTEM",
			[2] = "PROFESSION",
			[3] = "CLASS",
			[4] = "EMPTY",
			[5] = "CUSTOM",
		}
		
		dd:Open( this,
			"point", "TOPLEFT",
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
				
					dd:AddLine( "text", "BAR " .. barnum .. " CATEGORIES", "isTitle", true, "textHeight", 12 );
					
					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", "Currently Assigned:", "isTitle", true );
			
					for _, cat in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do
					
						cat_bar = self.db.profile.option.category.location[cat.id];
					
						if cat_bar and abs( cat_bar ) == barnum then
						
							local t = cat.type
							local n = cat.name;
							local c = GREEN_FONT_COLOR_CODE;
							if cat_bar < 0 then
								c = RED_FONT_COLOR_CODE;
							end
							
							-- assigned categories for this bar - displayed in green, hidden displayed in red
							dd:AddLine( "text", c .. n .. FONT_COLOR_CODE_CLOSE,
								"hasArrow", cat.id ~= 0,
								"value", "ASSIGNED_" .. cat.id
							);

						end
						
					end

					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", "Assignable Categories:", "isTitle", true );
					
					for _, v in ipairs( cat_type ) do
						dd:AddLine( "text", v,
							"hasArrow", true,
							"value", "CATEGORY_" .. v
						);
					end
					
					
				end
				
				
				if level == 2 and value then

					local k = strmatch( value, "ASSIGNED_(.*)" );
				
					if k then
					
						category_id = tonumber( k );
						
						dd:AddLine( "text", self:GetCategoryName( category_id ), "isTitle", true, "textHeight", 12 );
						dd:AddLine( "text", "", "disabled", true );

						dd:AddLine( "text", "Remove",
							"tooltipTitle", "Remove",
							"tooltipText", "click to remove " .. self:GetCategoryName( category_id ) .. " from bar " .. barnum .. " and return it to the default bar",
							"func", function()
								dd:Close();
								self:CategoryLocationSet( category_id, nil );
								self:GenerateContainerRebuildAll();
							end
						);

						dd:AddLine( "text", "Hidden",
							"tooltipTitle", "Hidden",
							"tooltipText", "click to toggle this categories hidden status.  items in a hidden category will not display in normal mode",
							"checked", self:CategoryHiddenCheck( category_id ),
							"func", function()
								self:CategoryHiddenToggle( category_id );
								self:GenerateContainerRebuildAll();
							end
						);
							
					end

				
					local k = strmatch( value, "CATEGORY_(.*)" );
					
					if k then
					
					dd:AddLine( "text", k, "isTitle", true, "textHeight", 12 );

					dd:AddLine( "text", "", "disabled", true );

					for _, cat in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do

						local t = cat.type
						if abs( self:CategoryLocationGet( cat.id ) ) == barnum then
							t = "IGNORE" -- change the category so it doesn't display
						end

						--self:Debug( "id=" .. cat.id .. ", type=[" .. cat.type .. "], value=[" .. value .. "]" )
						local n = cat.name

						if value == t then

							if self.db.profile.option.category.location[cat.id] then
								-- category is assigned to a bar - show the user where
								n = LIGHTYELLOW_FONT_COLOR_CODE .. n .. "  - " .. self.db.profile.option.category.location[cat.id] .. FONT_COLOR_CODE_CLOSE
							end

							dd:AddLine( "text", n,
								"tooltipTitle", "Category",
								"tooltipText", "Assign category " .. cat.name .. " to this bar",
								"func", function()
									self:CategoryLocationSet( cat.id, barnum );
									self:GenerateContainerRebuildAll();
								end
							);
						end

					end
					
					end

				end

			end
		);

	end
	
end


function ARKINV:ItemMenuOpen()

	if ARKINV_G.MODE_EDIT == false then
		return
	end

	
	local loc_id = self:UiLocationID( this:GetName() );
	
	local current_user = ARKINV_G.LOCATION[loc_id].USER;

	
	if dd:IsOpen( this ) then
	
		dd:Close()
		
	else
	
		local bag = getglobal( this:GetName() .. "ArkBag" ):GetID();
		local slot = getglobal( this:GetName() .. "ArkSlot" ):GetID();
		
		local i = self.db.account.cache.who[current_user].loc[loc_id].bag[bag].slot[slot];
		
		local _, _, _, ic = GetItemQualityColor( i.q );
		local barnum = abs( self:CategoryLocationGet( i.cat ) );
		
		local cat_type = {
			[1] = "SYSTEM",
			[2] = "PROFESSION",
			[3] = "CLASS",
			[4] = "EMPTY",
			[5] = "CUSTOM",
		};
	
	
		dd:Open( this,
			"point", "TOPLEFT",
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
			
					dd:AddLine( "text", "ITEM OPTIONS:", "isTitle", true, "textHeight", 12 );
					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", ic .. i.name .. FONT_COLOR_CODE_CLOSE, "isTitle", true, "textHeight", 12 );
					
					dd:AddLine( "text", "", "disabled", true );


					if not i.catdef then
						dd:AddLine( "text", "Default assignment: " .. GREEN_FONT_COLOR_CODE .. self:GetCategoryName( i.cat ) .. FONT_COLOR_CODE_CLOSE,
							"notClickable", true
						);
					else
						dd:AddLine( "text", "Current assignment: " .. GREEN_FONT_COLOR_CODE .. self:GetCategoryName( i.cat ) .. FONT_COLOR_CODE_CLOSE,
							"notClickable", true
						);
						dd:AddLine( "text", "Default assignment: " .. LIGHTYELLOW_FONT_COLOR_CODE .. self:GetCategoryName( i.catdef ) .. FONT_COLOR_CODE_CLOSE,
							"tooltipTitle", "Reset to default",
							"tooltipText", "click to reset the category for this item back to it's default value",
							"func", function()
								dd:Close();
								self:ItemCategorySet( i, nil );
								self:GenerateContainerRebuildAll();
							end
						);
					end
				
					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", "Assignable Categories:", "isTitle", true )
					for _, v in ipairs( cat_type ) do
						dd:AddLine( "text", v,
							"hasArrow", true,
							"tooltipTitle", "Assign Category",
							"tooltipText", "assign this item to a specific category",
							"value", "CATEGORY_" .. v
						);
					end
					
					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine(	"text", "Move " .. LIGHTYELLOW_FONT_COLOR_CODE .. self:GetCategoryName( i.cat ) .. FONT_COLOR_CODE_CLOSE .. " to Bar",
						"hasArrow", true,
						"hasSlider", true,
						"sliderValue", barnum,
						"sliderMin", 1,
						"sliderMax", self.db.account.cache.who[current_user].loc[loc_id].bar_count + 1,
						"sliderStep", 1,
						"sliderFunc", function( v )
							if self.db.profile.option.category.location[i.cat] ~= v then
								self.db.profile.option.category.location[i.cat] = v;
								self:GenerateContainerRebuildAll();
							end
						end
					);

					dd:AddLine( "text", "", "disabled", true );
					dd:AddLine( "text", "Debug Info",
						"hasArrow", true,
						"value", "DEBUG"
					);
					
				end

				if level == 2 then

					if value and string.sub( value, 1, 9 ) == "CATEGORY_" then
					
						for _, v in self:spairs( ARKINV_G.CATEGORY, function(a,b) return ARKINV_G.CATEGORY[a].name < ARKINV_G.CATEGORY[b].name end ) do
					
							local t = v.type
							if v.id == i.cat then
								t = "CATEGORY_HIDDEN"
							end
							
							--self:Debug( "id=" .. cat.id .. ", type=[" .. cat.type .. "], value=[" .. value .. "]" )
							if value == t then
							
								dd:AddLine( "text", v.name,
									"tooltipTitle", "Assign Category",
									"tooltipText", "assign this item to the " .. v.name .. " category",
									"func", function()
										dd:Close();
										self:ItemCategorySet( i, v.id );
										self:GenerateContainerRebuildAll();
									end
								);
							
							end
							
						end
						
					end
					
					if value == "DEBUG" then
					
						dd:AddLine( "text", "Bag: " .. GREEN_FONT_COLOR_CODE .. bag );
						dd:AddLine( "text", "Slot: " .. GREEN_FONT_COLOR_CODE .. slot );
						dd:AddLine( "text", "ID: " .. GREEN_FONT_COLOR_CODE .. i.id );
						dd:AddLine( "text", "Category: " .. GREEN_FONT_COLOR_CODE .. i.cat );
			
						if i.h then
							
							local _, _, irar, ilvl, imin, ityp, isub, icount, iloc, itxt = GetItemInfo( i.h );
							
							dd:AddLine( "text", "", "disabled", true );
							dd:AddLine( "text", "Rarity: " .. GREEN_FONT_COLOR_CODE .. irar );
							dd:AddLine( "text", "Level: " .. GREEN_FONT_COLOR_CODE .. ilvl );
							dd:AddLine( "text", "Min Level: " .. GREEN_FONT_COLOR_CODE .. imin );
							dd:AddLine( "text", "Type: " .. GREEN_FONT_COLOR_CODE .. ityp );
							dd:AddLine( "text", "Sub Type: " .. GREEN_FONT_COLOR_CODE .. isub );
							dd:AddLine( "text", "Stack Count: " .. GREEN_FONT_COLOR_CODE .. icount );
							dd:AddLine( "text", "Location: " .. GREEN_FONT_COLOR_CODE .. iloc );
							dd:AddLine( "text", "Texture: " .. GREEN_FONT_COLOR_CODE .. itxt );
							
							
						end
					
					
					
					
					end
					
				end

			end
		);
		
	end
	
end


function ARKINV:WhoMenuOpen( level )

	local loc_id = self:UiLocationID( this:GetName() );
	
	local current_user = ARKINV_G.LOCATION[loc_id].USER;
	
	local n, b;

	if dd:IsOpen( this ) then
	
		dd:Close()
		
	else
	
		dd:Open( this,
			"point", "TOPLEFT",
			"relativePoint" , "BOTTOMLEFT",
			"children", function( level, value )
			
				if level == 1 then
				
					if self:tableElements( self.db.account.cache.who ) == 1 then

						dd:AddLine(	"text", "no other character data to choose from",
							"nonClickable", true
						);
		
					else
					
						for k in pairs( self.db.account.cache.who ) do
							n = k
							if k == ARKINV_G.ME then
								n = GREEN_FONT_COLOR_CODE .. n .. FONT_COLOR_CODE_CLOSE
							end

							if k ~= current_user then
								dd:AddLine(	"text", n,
									"textHeight", 14,
									"isRadio", true,
									"checked", k == current_user,
									"func", function()
										ARKINV_G.LOCATION[loc_id].USER = k;
										dd:Close();
										self:GenerateContainerRebuild( loc_id );
									end
								);
							end
						end
					
					end
					
				end

			end
		);
		
	end
	
end


function ARKINV:IsTooltipReliable( bagnum )

	local r = true;
	
	if ARKINV_G.LOCATION[self:BagLocation( bagnum )].USER == ARKINV_G.ME then
	
		if ( ( self:BagLocation( bagnum ) == ARKINV_G.LOCATION_BANK ) and ARKINV_G.MODE_BANK == false ) then
			r = false;
		end
	
	else
		r = false;
	end

	return r
	
end


function ARKINV:RemoveOldOptions()

	-- don't store data in char db any more
	self:ResetDB( "char" );
	
	-- moved the background colour option
	if self.db.profile.option.window["background"] then
		self.db.profile.option.window.colour.background = self.db.profile.option.window.background;
		self.db.profile.option.window.background = nil;
	end
	
	-- moved the close on combat option
	if self.db.profile.option.window["combat"] then
		self.db.profile.option.window.auto.close.combat = self.db.profile.option.window.combat;
		self.db.profile.option.window.combat = nil;
	end

	-- moved the slot sort options
	if self.db.profile.option.slot["sort"] then
		self.db.profile.option.sort.type = self.db.profile.option.slot.sort;
		self.db.profile.option.slot.sort = nil;
	end
	
	-- remove none as an option to sort, use bag/slot instead
	if self.db.profile.option.sort.type == ARKINV_G.SLOT_SORT_NONE then
		self.db.profile.option.sort.type = ARKINV_G.SLOT_SORT_BAGSLOT
	end

	
	-- new id format
	local new_cat = { };
	local new_key = nil;
	for k, v in pairs( self.db.profile.option.category.item ) do
	
		new_key = k
	
		if strmatch( k, "^%d+$" ) then -- original format, just the number
			
			-- adding suffix and soulbound
			new_key = k .. ".0.0.0"
			
		elseif strmatch( k, "^%d+.%d+.%d+$" ) then -- second format id.suffix.soulbound
		
			-- moving soulbound and adding enchant
			local v1, v2, v3 = strmatch( k, "^(%d+).(%d+).(%d+)" );
			new_key = v1 .. "." .. v3 .. "." .. v2 .. ".0"
			
		end
	
		-- id . soulbound . suffix . enchant
		new_cat[new_key] = v;
	end
	self.db.profile.option.category.item = new_cat
	
end


function ARKINV:CacheCleanup()

	self:Debug( "CacheCleanup() start" );

--[[
	if self.db.profile.option.offline.bank == false then
		self:Debug( "clear bank is enabled" );
	else
		self:Debug( "clear bank is disabled" );
	end
	
	if self.db.profile.option.offline.alt == false then
		self:Debug( "clear bag is enabled" );
	else
		self:Debug( "clear bag is disabled" );
	end
]]--
		
	for w, wd in pairs( self.db.account.cache.who ) do

		if w ~= ARKINV_G.ME then
			if self.db.profile.option.offline.alt == false then
				self:Debug( "erasing cached data for " .. w );
				self.db.account.cache.who[w] = nil;
			end
		end


		for l, ld in pairs( wd.loc ) do
			
			--self:Debug( "checking cache: who=" .. w .. ", location=" .. l );
			
			if l == ARKINV_G.LOCATION_BANK and self.db.profile.option.offline.bank == false then
				-- erase bank if not needed
				self:Debug( "erasing cached bank data for " .. w );
				self.db.account.cache.who[w].loc[l] = nil;
			end
	
		end
	end

	self:Debug( "CacheCleanup() end" );
	
end


function ARKINV:UiLocationID( widget_name )

	loc_id = strmatch( widget_name, ARKINV_G.GUI_NAME .. "(%d+)" );
	
	if not loc_id then
		return nil
	end
	
	return tonumber( loc_id );
	
end


function ARKINV:BagScanRequiredAll()

	for k, v in pairs( ARKINV_G.LOCATION ) do
		self:BagScanRequired( v.IDS );
	end


end


function ARKINV:BagScanRequired( bagnum_table )

	self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " BagScanRequired() start" );

	local loc_id
	
	for _, bagnum in pairs( bagnum_table ) do
	
		self:Debug( date() .. " tagging bag " .. bagnum .. " for rescan" );
	
		loc_id = self:BagLocation( bagnum );
	
		ARKINV_G.LOCATION[loc_id].RESCAN[bagnum] = true;
		
	end

	self:Debug( GREEN_FONT_COLOR_CODE .. date() .. " BagScanRequired() end" );
	
end


