local L = AceLibrary( "AceLocale-2.2" ):new( "ARKINV" )

L:RegisterTranslations( "enUS", function() return {

	--key binding descriptions
	["BINDING_TOGGLE_BAG"] = "Toggle Bag",
	["BINDING_TOGGLE_KEY"] = "Toggle Keyring",
	["BINDING_TOGGLE_BANK"] = "Toggle Bank",
	["BINDING_TOGGLE_EDIT"] = "Toggle Edit Mode",
	
	-- item types - must match wow client language
	["ITEM_ARMOR"] = "Armor",
	["ITEM_CONSUMABLE"] = "Consumable",
	["ITEM_CONTAINER"] = "Container",
	["ITEM_CONTAINER_BAG"] = "Bag",
	["ITEM_CONTAINER_SOULSHARD"] = "Soul Bag",
	["ITEM_CONTAINER_HERB"] = "Herb Bag",
	["ITEM_CONTAINER_ENCHANTING"] = "Enchanting Bag",
	["ITEM_CONTAINER_ENGINEERING"] = "Engineering Bag",
	["ITEM_CONTAINER_GEM"] = "Gem Bag",
	["ITEM_CONTAINER_MINING"] = "Mining Bag",
	["ITEM_KEY"] = "Key", 
	["ITEM_MISCELLANEOUS"] = "Miscellaneous", 
	["ITEM_REAGENT"] = "Reagent",
	["ITEM_RECIPE"] = "Recipe",
	["ITEM_PROJECTILE"] = "Projectile",
	["ITEM_PROJECTILE_BULLET"] = "Bullet",
	["ITEM_PROJECTILE_ARROW"] = "Arrow",
	["ITEM_QUEST"] = "Quest",
	["ITEM_QUIVER"] = "Quiver",
	["ITEM_QUIVER_BULLET"] = "Ammo Pouch",
	["ITEM_QUIVER_ARROW"] = "Quiver",
	["ITEM_TRADE_GOODS"] = "Trade Goods",
	["ITEM_WEAPON"] = "Weapon",

	["ITEM_REQUIRES"] = "Requires",
	["ITEM_PROFESSION_ALCHEMY"] = "Alchemy",
	["ITEM_PROFESSION_BLACKSMITHING"] = "Blacksmithing",
	["ITEM_PROFESSION_COOKING"] = "Cooking",
	["ITEM_PROFESSION_ENCHANTING"] = "Enchanting",
	["ITEM_PROFESSION_ENGINEERING"] = "Engineering",
	["ITEM_PROFESSION_FIRST_AID"] = "First Aid",
	["ITEM_PROFESSION_FISHING"] = "Fishing",
	["ITEM_PROFESSION_HERBALISM"] = "Herbalism",
	["ITEM_PROFESSION_JEWELCRAFTING"] = "Jewelcrafting",
	["ITEM_PROFESSION_LEATHERWORKING"] = "Leatherworking",
	["ITEM_PROFESSION_MINING"] = "Mining",
	["ITEM_PROFESSION_SKINNING"] = "Skinning",
	["ITEM_PROFESSION_TAILORING"] = "Tailoring",

	
	-- tooltip category - must match wow client language
	["TOOLTIP_SOULBOUND"] = "Soulbound",
	["TOOLTIP_MOUNT"] = "Requires Riding",
	["TOOLTIP_POTION"] = "Potion",
	["TOOLTIP_ELIXIR"] = "Elixir",
	["TOOLTIP_CLASS"] = "Classes: ",
	
	["TOOLTIP_FOOD"] = "Must remain seated while eating",
	["TOOLTIP_DRINK"] = "Must remain seated while drinking",
	["TOOLTIP_PET"] = "Click to summon and dismiss your",
	["TOOLTIP_HEALPOT"] = "Restores %d+ to %d+ health",
	["TOOLTIP_MANAPOT"] = "Restores %d+ to %d+ mana",
	
	["TOOLTIP_CLASS_DRUID"] = "Druid",
	["TOOLTIP_CLASS_HUNTER"] = "Hunter",
	["TOOLTIP_CLASS_MAGE"] = "Mage",
	["TOOLTIP_CLASS_PALADIN"] = "Paladin",
	["TOOLTIP_CLASS_PRIEST"] = "Priest",
	["TOOLTIP_CLASS_ROGUE"] = "Rogue",
	["TOOLTIP_CLASS_SHAMAN"] = "Shaman",
	["TOOLTIP_CLASS_WARLOCK"] = "Warlock",
	["TOOLTIP_CLASS_WARRIOR"] = "Warrior",


	
	-- BAG NAMES - USED TO TAG EMPTY SLOTS
	["NAME_CONTAINER_SOULSHARD"] = "Shard",
	["NAME_CONTAINER_HERB"] = "Herb",
	["NAME_CONTAINER_ENCHANTING"] = "Ench",
	["NAME_CONTAINER_ENGINEERING"] = "Eng",
	["NAME_CONTAINER_GEM"] = "Gem",
	["NAME_CONTAINER_MINING"] = "Mine",
	["NAME_CONTAINER_PROJECTILE"] = "Ammo",
	["NAME_CONTAINER_PROJECTILE_BULLET"] = "Bullet",
	["NAME_CONTAINER_PROJECTILE_ARROW"] = "Arrow",
	["NAME_CONTAINER_KEY"] = "Key",
	["NAME_CONTAINER_UNKNOWN"] = "Unknown",
	["NAME_CONTAINER_BAG"] = "Bag",
	
	-- category names
	["CATEGORY_SYSTEM"] = "SYSTEM",
	["CATEGORY_PROFESSION"] = "PROFESSION",
	["CATEGORY_CLASS"] = "CLASS",
	["CATEGORY_CUSTOM"] = "CUSTOM",
	
	-- system categories
	["CATEGORY_CONSUMABLE"] = "CONSUMABLE",
	["CATEGORY_CONTAINER"] = "CONTAINER",
	["CATEGORY_KEY"] = "KEY",
	["CATEGORY_MISCELLANEOUS"] = "MISC",
	["CATEGORY_QUEST"] = "QUEST",
	["CATEGORY_REAGENT"] = "REAGENT",
	["CATEGORY_RECIPE"] = "RECIPE",
	["CATEGORY_PROJECTILE"] = "PROJECTILE",
	["CATEGORY_PROJECTILE_BULLET"] = "PROJECTILE (BULLET)",
	["CATEGORY_PROJECTILE_ARROW"] = "PROJECTILE (ARROW)",
	["CATEGORY_TRADE_GOODS"] = "TRADE GOODS",

	["CATEGORY_DEFAULT"] = "DEFAULT",
	["CATEGORY_TRASH"] = "TRASH",
	["CATEGORY_SOULSHARD"] = "SOUL SHARD",
	["CATEGORY_SOULBOUND"] = "SOULBOUND",
	["CATEGORY_SOULBOUND_EQUIPMENT"] = "SOULBOUND EQUIPMENT",
	["CATEGORY_EQUIPMENT"] = "EQUIPMENT",
	["CATEGORY_MOUNT"] = "MOUNT",
	["CATEGORY_PET_NONCOMBAT"] = "PET (NON-COMBAT)",

	["CATEGORY_FOOD"] = "FOOD",
	["CATEGORY_DRINK"] = "DRINK",
	["CATEGORY_MANAPOT"] = "MANA POTION",
	["CATEGORY_HEALPOT"] = "HEALING POTION",
	["CATEGORY_CORE_MATS"] = "CORE MATS",

	
	
	-- empty categories
	["CATEGORY_EMPTY"] = "EMPTY", -- generic empty, also used for category menu
	["CATEGORY_EMPTY_KEY"] = "EMPTY (KEYRING)",
	["CATEGORY_EMPTY_PROJECTILE"] = "EMPTY (PROJECTILE)",
	["CATEGORY_EMPTY_PROJECTILE_BULLET"] = "EMPTY (PROJECTILE - BULLET)",
	["CATEGORY_EMPTY_PROJECTILE_ARROW"] = "EMPTY (PROJECTILE - ARROW)",
	["CATEGORY_EMPTY_SOULSHARD"] = "EMPTY (SOUL SHARD)",
	["CATEGORY_EMPTY_HERB"] = "EMPTY (HERB)",
	["CATEGORY_EMPTY_ENCHANTING"] = "EMPTY (ENCHANTING)",
	["CATEGORY_EMPTY_ENGINEERING"] = "EMPTY (ENGINEERING)",
	["CATEGORY_EMPTY_GEM"] = "EMPTY (GEM)",
	["CATEGORY_EMPTY_MINING"] = "EMPTY (MINING)",
	["CATEGORY_EMPTY_BAG"] = "EMPTY (BAG)",
	["CATEGORY_EMPTY_UNKNOWN"] = "EMPTY (UNKNOWN)",

	
	-- profession categories
	["CATEGORY_PROFESSION_ALCHEMY"] = "ALCHEMY",
	["CATEGORY_PROFESSION_BLACKSMITHING"] = "BLACKSMITHING",
	["CATEGORY_PROFESSION_COOKING"] = "COOKING",
	["CATEGORY_PROFESSION_ENCHANTING"] = "ENCHANTING",
	["CATEGORY_PROFESSION_ENGINEERING"] = "ENGINEERING",
	["CATEGORY_PROFESSION_FIRST_AID"] = "FIRST AID",
	["CATEGORY_PROFESSION_FISHING"] = "FISHING",
	["CATEGORY_PROFESSION_HERBALISM"] = "HERBALISM",
	["CATEGORY_PROFESSION_JEWELCRAFTING"] = "JEWELCRAFTING",
	["CATEGORY_PROFESSION_LEATHERWORKING"] = "LEATHERWORKING",
	["CATEGORY_PROFESSION_MINING"] = "MINING",
	["CATEGORY_PROFESSION_SKINNING"] = "SKINNING",
	["CATEGORY_PROFESSION_TAILORING"] = "TAILORING",
	
		
	-- class categories
	["CATEGORY_CLASS_DRUID"] = "DRUID",
	["CATEGORY_CLASS_HUNTER"] = "HUNTER",
	["CATEGORY_CLASS_MAGE"] = "MAGE",
	["CATEGORY_CLASS_PALADIN"] = "PALADIN",
	["CATEGORY_CLASS_PRIEST"] = "PRIEST",
	["CATEGORY_CLASS_ROGUE"] = "ROGUE",
	["CATEGORY_CLASS_SHAMAN"] = "SHAMAN",
	["CATEGORY_CLASS_WARLOCK"] = "WARLOCK",
	["CATEGORY_CLASS_WARRIOR"] = "WARRIOR",


	-- location names
	["LOCATION_BAG"] = "Bags",
	["LOCATION_BANK"] = "Bank",
	["LOCATION_KEY"] = "Keyring",
	
	["STATUS_OFFLINE"] = "Offline",
	["STATUS_NO_DATA"] = "NO DATA",
	["STATUS_FULL"] = "FULL",
	
		
} end )
